
# LeGuymelefUI script

# Add-on informations
bl_info = {
    "name": "LeGuymelef UI",
    "description": "UI for models.",
    "author": "LeGuymelef",
    "version": (1, 7, 0),
    "blender": (3, 5, 0),
    "warning": "",
    "category": "User Interface",
}


import bpy
import addon_utils
import sys
import os
import re
import time
from bpy.props import *
from mathutils import Vector, Color
import webbrowser
import math
from mathutils import *

# ------------------------------------------------------------------------
#    Initialization
# ------------------------------------------------------------------------


def model_list(self, context):
    ModelList = []
    ModelList.append(("None", "None", "None", 0))
    count=1
    for obj in bpy.data.objects:
        if "Body" in obj.name and obj.parent and obj.parent.type == 'ARMATURE' and "_rig" in obj.parent.name:
            if obj.name == str(obj.parent.name.split('_rig',1)[0]+' Body'):
                if "Anus Open" in obj.parent.data.bones and "Vag Open" in obj.parent.data.bones or "GenControl01" in obj.parent.data.bones and "Testes" in obj.parent.data.bones:
                    identifier=str(obj.name.split(' ',1)[0])
                    name=str(obj.name.split(' ',1)[0])
                    description=str(obj.name.split(' ',1)[0])
                    number = count
                    ModelList.append((identifier, name, description, number))
                    count += 1
    return ModelList


def hair_list(self, context):
    HairObjList = []
    HairObjList.append(("Bald", "Bald", "Bald", 0))
    count=1
    if bpy.context.scene.model_tools.model_name != "None":
        for collection in bpy.data.collections:
            if bpy.context.scene.model_tools.model_name in collection.name and "Hair" in collection.name:
                for obj in collection.objects: 
                    if obj.type == "MESH" and "Hair" in obj.name:
                        identifier=str(obj.name)
                        name=str(obj.name)
                        description=str(obj.name)
                        number = count
                        HairObjList.append((identifier, name, description, number))
                        count += 1
    return HairObjList


def outfit_list(self, context):
    OutfitColList = []
    OutfitColList.append(("Nude", "Nude", "Nude", 0))
    count=1
    if bpy.context.scene.model_tools.model_name != "None":
        for collection in bpy.data.collections:
            if bpy.context.scene.model_tools.model_name in collection.name and "Outfit" in collection.name:
                identifier=str(collection.name)
                name=str(collection.name)
                description=str(collection.name)
                number = count
                OutfitColList.append((identifier, name, description, number))
                count += 1
    return OutfitColList

def hair_update(self,context):

    HairObjList = []
    if bpy.context.scene.model_tools.model_name != "None":
        for collection in bpy.data.collections:
            if bpy.context.scene.model_tools.model_name in collection.name and "Hair" in collection.name:
                for obj in collection.objects: 
                    if obj.type == "MESH" and "Hair" in obj.name:
                        HairObjList.append(obj.name)
        
        if bpy.context.scene.model_tools.hair_name != "Bald":
            for ob in HairObjList:
                bpy.data.objects[ob].hide_viewport = True
                bpy.data.objects[ob].hide_render = True
                if bpy.data.objects[ob].parent and bpy.data.objects[ob].parent.type == 'ARMATURE' and bpy.data.objects[ob].parent.name != bpy.context.scene.model_tools.model_name+"_rig":
                    bpy.data.objects[ob].parent.hide_viewport = True
                    bpy.data.objects[ob].parent.hide_render = True
            bpy.data.objects[bpy.context.scene.model_tools.hair_name].hide_viewport = False
            bpy.data.objects[bpy.context.scene.model_tools.hair_name].hide_render = False
            if bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent and bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent.type == 'ARMATURE' and bpy.data.objects[ob].parent.name != bpy.context.scene.model_tools.model_name+"_rig":
                bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent.hide_viewport = False
                bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent.hide_render = False
        else:
            for ob in HairObjList:
                bpy.data.objects[ob].hide_viewport = True
                bpy.data.objects[ob].hide_render = True
                if bpy.data.objects[ob].parent and bpy.data.objects[ob].parent.type == 'ARMATURE'and bpy.data.objects[ob].parent.name != bpy.context.scene.model_tools.model_name+"_rig":
                    bpy.data.objects[ob].parent.hide_viewport = True
                    bpy.data.objects[ob].parent.hide_render = True            
    return

def outfit_update(self,context):

    OutfitColList = []
    if bpy.context.scene.model_tools.model_name != "None":
        for collection in bpy.data.collections:
            if bpy.context.scene.model_tools.model_name in collection.name and "Outfit" in collection.name:
                OutfitColList.append(collection.name)
        
        for col in OutfitColList:
            if bpy.context.scene.model_tools.outfit_name=='Nude':
                for col in OutfitColList:
                        bpy.context.view_layer.layer_collection.children[col].exclude = True
                
            else:
                for col in OutfitColList:
                        bpy.context.view_layer.layer_collection.children[col].exclude = True

                bpy.context.view_layer.layer_collection.children[bpy.context.scene.model_tools.outfit_name].exclude = False
         
    return



class ModelInfos(bpy.types.PropertyGroup):

    # apply values to LOC ROT SCL
    model_name : bpy.props.EnumProperty(
        name="",
        description="",
        items=model_list
        )

    outfit_name : bpy.props.EnumProperty(
        name="",
        description="",
        items=outfit_list,
        update=outfit_update
        )

    hair_name : bpy.props.EnumProperty(
        name="",
        description="",
        items=hair_list,
        update=hair_update
        )


def property_name_cleanup(property):
    if "eCTRL" in property:
        property=property.replace("eCTRL","")
    if "FBM" in property:
        property=property.replace("FBM","")
    if "PBM" in property:
        property=property.replace("PBM","")
    if "CTRL" in property:
        property=property.replace("CTRL","")
    if "facs_ctrl_" in property:
        property=property.replace("facs_ctrl_","")
    if "VYK Nails " in property:
        property=property.replace("VYK Nails ","")       
    return property


# ------------------------------------------------------------------------
#    Global model definitions
# ------------------------------------------------------------------------


# LINKS

# List of the links which will be shown in the Link tab
# Leave them to "" if you don't want to show them
url_website = ""
url_patreon = "https://www.patreon.com/LeGuymelef"
url_twitter = "https://twitter.com/LeGuymelef"
url_smutbase = "https://smutba.se/user/12306/"
url_reportbug = ""
url_videotut = "https://open3dlab.com/project/31128/"
url_outfitlibrary = "https://www.patreon.com/posts/70977175"

bpy.types.Scene.url_website = url_website
bpy.types.Scene.url_patreon = url_patreon
bpy.types.Scene.url_twitter = url_twitter
bpy.types.Scene.url_smutbase = url_smutbase
bpy.types.Scene.url_reportbug = url_reportbug
bpy.types.Scene.url_videotut = url_videotut
bpy.types.Scene.url_outfitlibrary = url_outfitlibrary

bpy.types.Scene.url_website = bpy.props.StringProperty(default="")
bpy.types.Scene.url_patreon = bpy.props.StringProperty(default="")
bpy.types.Scene.url_twitter = bpy.props.StringProperty(default="")
bpy.types.Scene.url_smutbase = bpy.props.StringProperty(default="")
bpy.types.Scene.url_reportbug = bpy.props.StringProperty(default="")
bpy.types.Scene.url_videotut = bpy.props.StringProperty(default="")
bpy.types.Scene.url_outfitlibrary = bpy.props.StringProperty(default="")



# ------------------------------------------------------------------------
#    Model & Performance Properties
# ------------------------------------------------------------------------

def engine_eevee(self, context):

    if self.engine_eevee:
        self.engine_cycles = False
        
    for obj in bpy.data.objects:
        if obj.type == "MESH":
            for mat in obj.data.materials:
                if mat != None and mat.use_nodes:
                    for node in mat.node_tree.nodes:
                        if node.type == 'GROUP' and "Shader" in node.node_tree.name:
                            if node.inputs[0].name == 'Engine':
                                node.inputs[0].default_value = 1
                            ao_node = node.node_tree.nodes.get("Ambient Occlusion")
                            if ao_node:
                                ao_node.mute = False
                                ao_node.outputs[0].links[0].to_node.mute = False                            
                            if obj.users_collection:
                                if " Hair" in obj.users_collection[0].name:
                                    if mat.blend_method == 'HASHED':
                                        if node.inputs.get("Subsurface").links and node.inputs.get("Subsurface").links[0].from_socket.type == 'VALUE':
                                            mat.node_tree.links.remove(node.inputs.get("Subsurface").links[0])
                                        node.inputs.get("Subsurface").default_value =0.150
                        if node.type == 'GROUP' and "Wet" in node.node_tree.name:
                            principled = node.node_tree.nodes.get("Principled BSDF")
                            if principled:
                                principled_ior = principled.inputs.get("IOR")
                                principled_ior.default_value = 0
   
    return

bpy.types.Scene.engine_eevee = bpy.props.BoolProperty(default = True,
                                                            name="",
                                                            description="Removes AO and hair subsurface \nThis won't change the actual render engine",
                                                            update = engine_eevee)
def engine_cycles(self, context):

    if self.engine_cycles:
        self.engine_eevee = False
        
    for obj in bpy.data.objects:
        if obj.type == "MESH":
            for mat in obj.data.materials:
                if mat != None and mat.use_nodes:
                    for node in mat.node_tree.nodes:
                        if node.type == 'GROUP' and "Shader" in node.node_tree.name:
                            if node.inputs[0].name == 'Engine':
                                node.inputs[0].default_value = 0    
                            ao_node = node.node_tree.nodes.get("Ambient Occlusion")
                            if ao_node:
                                ao_node.mute = True
                                ao_node.outputs[0].links[0].to_node.mute = True 
                            if obj.users_collection:
                                if " Hair" in obj.users_collection[0].name:
                                    if node.inputs.get("Subsurface").links and node.inputs.get("Subsurface").links[0].from_socket.type == 'VALUE':
                                        mat.node_tree.links.remove(node.inputs.get("Subsurface").links[0])
                                    node.inputs.get("Subsurface").default_value =0
                        if node.type == 'GROUP' and "Wet" in node.node_tree.name:
                            principled = node.node_tree.nodes.get("Principled BSDF")
                            if principled:
                                principled_ior = principled.inputs.get("IOR")
                                principled_ior.default_value = 1.33

    return

bpy.types.Scene.engine_cycles = bpy.props.BoolProperty(default = False,
                                                            name="",
                                                            description="Removes AO and hair subsurface \nThis won't change the actual render engine",
                                                            update = engine_cycles)


def mannequinmode_update(self, context):
    
    scene = context.scene
    model_tools = scene.model_tools 
    if model_tools.model_name != "None":
        if self.mannequinmode:
            bpy.data.objects[model_tools.model_name+' Body'].hide_viewport = True
            bpy.data.objects[model_tools.model_name+' Body'].hide_render = True
            bpy.context.view_layer.layer_collection.children[model_tools.model_name+' Mannequin'].exclude = False
        else:
            bpy.data.objects[model_tools.model_name+' Body'].hide_viewport = False
            bpy.data.objects[model_tools.model_name+' Body'].hide_render = False
            bpy.context.view_layer.layer_collection.children[model_tools.model_name+' Mannequin'].exclude = True

    return

bpy.types.Object.mannequinmode = bpy.props.BoolProperty(default = False,
                                                            name="Mannequin Mode",
                                                            description="",
                                                            update = mannequinmode_update)  
                                                            
# ------------------------------------------------------------------------
#   Material Retrieval
# ------------------------------------------------------------------------

def TorsoMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "Torso" in mat.name and a == 0:
                a=a+1    
                return mat
            
def FaceMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "Face" in mat.name and a == 0:
                a=a+1    
                return mat

def LegsMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "Legs" in mat.name and a == 0:
                a=a+1    
                return mat

def FingerNailsMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "FingerNails" in mat.name and a == 0:
                a=a+1    
                return mat

def ToeNailsMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "ToeNails" in mat.name and a == 0:
                a=a+1    
                return mat
            
def GenitalsMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "Genitals" in mat.name and a == 0:
                a=a+1    
                return mat
            
def TeethMat():
    a=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if "Teeth" in mat.name and a == 0:
                a=a+1    
                return mat    

def TorsoMakeupNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TorsoMat().node_tree.nodes:
            if node.type == 'GROUP' and "TorsoMakeup" in node.node_tree.name:
                return node

def ShaderNode(material):
    if bpy.context.scene.model_tools.model_name != "None":
        for node in material.node_tree.nodes:
            if node.type == 'GROUP' and "Shader" in node.node_tree.name:
                return node

def SpecularDetailsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TorsoMat().node_tree.nodes:
            if node.type == 'GROUP' and "SpecularDetailsNode" in node.node_tree.name:
                return node


def VeinsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TorsoMat().node_tree.nodes:
            if "Veins Amount" in node.name :
                return node

def SkinDetailsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TorsoMat().node_tree.nodes:
            if node.type == 'GROUP' and "Skin Details" in node.node_tree.name:
                return node

def BumpNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TorsoMat().node_tree.nodes:
            if node.type == 'GROUP' and "Bump Node" in node.node_tree.name:
                return node

def FaceMakeupNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FaceMat().node_tree.nodes:
            if node.type == 'GROUP' and "FaceMakeup" in node.node_tree.name:
                return node

def MetallicLipsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FaceMat().node_tree.nodes:
            if "Metallic Lips" in node.name:
                return node

def SetLipsGlossNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FaceMat().node_tree.nodes:
            if node.type == 'GROUP' and "SetLipsGloss" in node.node_tree.name or node.name == "SetLipsGloss":
                return node

def FaceDetailsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FaceMat().node_tree.nodes:
            if node.type == 'GROUP' and "FaceDetails" in node.node_tree.name:
                return node

def LipsGlossNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FaceMat().node_tree.nodes:
            if "LipsGloss" in node.name:
                return node

def SoleBlushNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in LegsMat().node_tree.nodes:
            if "SoleBlush" in node.name:
                return node

def FeetDetailsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in LegsMat().node_tree.nodes:
            if node.type == 'GROUP' and "FeetDetails" in node.node_tree.name:
                return node

def FingerFrenchNailsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FingerNailsMat().node_tree.nodes:
            if node.type == 'GROUP' and "FingerFrenchNails" in node.node_tree.name:
                return node

def SetFingerNailsColorNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FingerNailsMat().node_tree.nodes:
            if "SetFingerNailsColor" in node.name:
                return node

def FingerNailsSpecNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in FingerNailsMat().node_tree.nodes:
            if "FingerNailsSpec" in node.name:
                return node


def ToesFrenchNailsNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in ToeNailsMat().node_tree.nodes:
            if node.type == 'GROUP' and "ToesFrenchNails" in node.node_tree.name:
                return node

def SetToeNailsColorNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in ToeNailsMat().node_tree.nodes:
            if "SetToeNailsColor" in node.name:
                return node

def ToeNailsSpecNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in ToeNailsMat().node_tree.nodes:
            if "ToeNailsSpec" in node.name:
                return node

def GenitaliaMakeupNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in GenitalsMat().node_tree.nodes:
            if node.type == 'GROUP' and "GenitaliaMakeup" in node.node_tree.name:
                return node

def GenitaliaGroupNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in GenitalsMat().node_tree.nodes:
            if node.type == 'GROUP' and "Genitalia Group" in node.node_tree.name or node.type == 'GROUP' and "New Genitalia" in node.node_tree.name:
                return node

def PussyWetness():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in GenitalsMat().node_tree.nodes:
            if node.type == 'GROUP' and "Pussy Wetness" in node.node_tree.name:
                return node

def TeethColorNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TeethMat().node_tree.nodes:
            if "Teeth Color" in node.name:
                return node

#This is a test to see if it's an older model, if the node exists it means it should use the legacy stuff
def DirtNode():
    if bpy.context.scene.model_tools.model_name != "None":
        for node in TorsoMat().node_tree.nodes:
            if node.name == "Dirt":
                return node                


# ------------------------------------------------------------------------
#   Body & Makeup Settings
# ------------------------------------------------------------------------

default_color = 1,1,1,1

def BodyTextCount():
    BodyText=0
    BodyAltText=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if mat != None and mat.use_nodes:
                if "Eyes" not in mat.name:
                    for node in mat.node_tree.nodes:
                        if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                            if not BodyAltText:
                                for input in node.inputs:
                                    if input.links and input.type == 'RGBA':
                                        BodyText=BodyText+1
                            BodyAltText=BodyAltText+1
            return(BodyText)            
    else:
        return 0 

def EyesTextCount():
    EyesText=0
    EyesAltText=0
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if mat != None and mat.use_nodes:
                if "Eyes" in mat.name:
                    for node in mat.node_tree.nodes:
                        if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                            if not EyesAltText:
                                for input in node.inputs:
                                    if input.links and input.type == 'RGBA':
                                        EyesText=EyesText+1
                            EyesAltText=EyesAltText+1
        return(EyesText)            
    else:
        return 0 
                
def alternative_body_text(self, context):
    
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if mat != None and mat.use_nodes:
                for node in mat.node_tree.nodes:
                    if "Eyes" not in mat.name:
                        if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                            for input in node.inputs:
                                if input.name == "Texture Number" and input.type == "INT":
                                    input.default_value = self.body_alt_text
                                elif input.name == "Texture Number" and input.type == 'VALUE' and input.links:
                                    if type(input.links[0].from_node) is bpy.types.ShaderNodeValue:
                                        mat.node_tree.nodes[input.links[0].from_node.name].outputs[0].default_value = self.body_alt_text
    return






def alternative_eyes_text(self, context):
    
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if mat != None and mat.use_nodes:
                for node in mat.node_tree.nodes:
                    if "Eyes" in mat.name:
                        if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                            for input in node.inputs:
                                if input.name == "Texture Number" and input.type == "INT":
                                    input.default_value = self.eyes_alt_text
                                elif input.name == "Texture Number" and input.type == 'VALUE' and input.links:
                                    if type(input.links[0].from_node) is bpy.types.ShaderNodeValue:
                                        mat.node_tree.nodes[input.links[0].from_node.name].outputs[0].default_value = self.eyes_alt_text
    return

bpy.types.Object.body_alt_text = bpy.props.IntProperty(default = 1,
                                                            min = 1,
                                                            max = 14,
                                                            name = "",
                                                            description = "Body Texture Selection",
                                                            update = alternative_body_text)


bpy.types.Object.eyes_alt_text = bpy.props.IntProperty(default = 1,
                                                            min = 1,
                                                            max = 14,
                                                            name = "",
                                                            description = "Eyes Texture Selection",
                                                            update = alternative_eyes_text)
            
def finger_french_nails_set(self,context):
    
    if self.French_Finger_Nails_Bool:
        FingerFrenchNailsNode().inputs[2].default_value=1
    else:
        FingerFrenchNailsNode().inputs[2].default_value=0
        FingerFrenchNailsNode().inputs[3].default_value = default_color
        
bpy.types.Object.French_Finger_Nails_Bool= bpy.props.BoolProperty(update=finger_french_nails_set)

def toes_french_nails_set(self,context):
    
    if self.French_Toes_Nails_Bool:
        ToesFrenchNailsNode().inputs[2].default_value=1
    else:
        ToesFrenchNailsNode().inputs[2].default_value=0
        ToesFrenchNailsNode().inputs[3].default_value = default_color
        
bpy.types.Object.French_Toes_Nails_Bool= bpy.props.BoolProperty(update=toes_french_nails_set)

def blush_color_set(self,context):
    
    if not self.Blush_Bool:
        FaceMakeupNode().inputs[9].default_value=default_color

bpy.types.Object.Blush_Bool = bpy.props.BoolProperty(update=blush_color_set)

def soleblush_color_set(self,context):
    
    if not self.Sole_Blush_Bool:
        SoleBlushNode().inputs[2].default_value=default_color

bpy.types.Object.Sole_Blush_Bool = bpy.props.BoolProperty(update=soleblush_color_set)

def eyeshadow_color_set(self,context):
    
    if not self.Eyeshadow_Bool:
        FaceMakeupNode().inputs[8].default_value=default_color

bpy.types.Object.Eyeshadow_Bool = bpy.props.BoolProperty(update=eyeshadow_color_set)


def fingernails_color_set(self, context):
    
    if not self.Fingernails_Bool:
        SetFingerNailsColorNode().inputs[0].default_value=0
        SetFingerNailsColorNode().inputs[7].default_value=default_color
    else:
        SetFingerNailsColorNode().inputs[0].default_value=1

bpy.types.Object.Fingernails_Bool = bpy.props.BoolProperty(update=fingernails_color_set)

def toenails_color_set(self, context):
    
    if not self.Toenails_Bool:
        SetToeNailsColorNode().inputs[0].default_value=0
        SetToeNailsColorNode().inputs[7].default_value=default_color
    else:
        SetToeNailsColorNode().inputs[0].default_value=1

bpy.types.Object.Toenails_Bool = bpy.props.BoolProperty(update=toenails_color_set)

def lips_color_set(self,context):
    
    if not self.Lips_Bool:
        FaceMakeupNode().inputs[6].default_value=default_color

bpy.types.Object.Lips_Bool = bpy.props.BoolProperty(update=lips_color_set)


def bloodcolor_update(self, context):

    for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+' Body'].data.materials:
        if mat != None and mat.use_nodes:
            for node in mat.node_tree.nodes:
                if "Blood Color" in node.name:
                    node.outputs[0].default_value = self.bloodcolor
    return


bpy.types.Object.bloodcolor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=bloodcolor_update)


def veinscolor_update(self, context):

    for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+' Body'].data.materials:
        if mat != None and mat.use_nodes:
            for node in mat.node_tree.nodes:
                if "Veins Color" in node.name:
                    node.outputs[0].default_value = self.veinscolor
    return


bpy.types.Object.veinscolor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=veinscolor_update)




# ------------------------------------------------------------------------
#   Legacy Body & Makeup Settings
# ------------------------------------------------------------------------
def LegacyNodes(self,context):
    if bpy.context.scene.model_tools.model_name != "None":
        for mat in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].data.materials:
            if mat != None and mat.use_nodes:
                for node in mat.node_tree.nodes:
                    if node.name == "Tan":
                        node.outputs[0].default_value = self.LegacyTan
                    if node.name == "Tan Lines":
                        node.outputs[0].default_value = self.LegacyTanLines
                    if node.name == "Scratches":
                        node.outputs[0].default_value = self.LegacyScratches
                    if node.name == "Dirt":
                        node.outputs[0].default_value = self.LegacyDirt
                    if node.name == "Spanked":
                        node.outputs[0].default_value = self.LegacySpanked
                    if node.name == "Oily":
                        node.outputs[0].default_value = self.LegacyOily                                       
                    if node.name == "Foam":
                        node.outputs[0].default_value = self.LegacyFoam                    
                    if node.name == "Wet":
                        node.outputs[0].default_value = self.LegacyWet                     
                    if node.name == "Lip Gloss":
                        node.outputs[0].default_value = self.LegacyGloss  
                    if node.name == "SwellColor":
                        node.outputs[0].default_value = self.LegacyGenSwellColor 
                    if node.name == "GenColor":
                        node.outputs[0].default_value = self.LegacyGenColor 
                    if node.name == "Blood":
                        node.outputs[0].default_value = self.LegacyBlood 
                    if node.name == "Veins":
                        node.outputs[0].default_value = self.LegacyVeins
                    if node.name == "WetSweatSwitch":
                        node.outputs[0].default_value = self.LegacyWetSwitch
                    if node.name == "Tan Lines Type":
                        node.outputs[0].default_value = self.LegacyTanLinesType                         
                    if node.name == "Mascara Tears":
                        node.outputs[0].default_value = self.LegacyMascaraTears 
                    if node.name == "Mascara Smudge":
                        node.outputs[0].default_value = self.LegacyMascaraSmudge 
                    if node.name == "Mascara Tears Type":
                        node.outputs[0].default_value = self.LegacyMascaraTearsType                          
                    if node.type == 'GROUP' and "Sweat" in node.node_tree.name:
                        for input in node.inputs:
                            if input.name == "Wet Value" and not input.links:                               
                                input.default_value = self.LegacyWet
                            if input.name == "Wet / Sweat Switch" and not input.links:
                                input.default_value = self.LegacyWetSwitch                               
                    if node.type == 'GROUP' and "Shader" in node.node_tree.name:
                        for input in node.inputs:
                            if input.name == "Subsurface":
                                input.default_value = self.LegacySubsurface
                    if node.name == "Finger Nails Custom":
                        node.outputs[0].default_value = self.LegacyFingerNailsColorBool
                    if node.name == "Finger Nails Color":
                        if self.LegacyFingerNailsColorBool:
                            node.outputs[0].default_value = self.LegacyFingerNailsColor
                        else:
                            node.outputs[0].default_value = (1.,1.,1.,1.)                           
                    if node.name == "Toe Nails Custom":
                        node.outputs[0].default_value = self.LegacyToeNailsColorBool
                    if node.name == "Toe Nails Color":
                        if self.LegacyToeNailsColorBool:
                            node.outputs[0].default_value = self.LegacyToeNailsColor
                        else:
                            node.outputs[0].default_value = (1.,1.,1.,1.)                                                               
                    if node.name == "Blush Color":
                        if self.LegacyBlushColorBool:
                            node.outputs[0].default_value = self.LegacyBlushColor
                        else:
                            node.outputs[0].default_value = (1.,1.,1.,1.) 
                    if node.name == "Lips Color":
                        if self.LegacyLipstickColorBool:
                            node.outputs[0].default_value = self.LegacyLipstickColor
                        else:
                            node.outputs[0].default_value = (1.,1.,1.,1.) 
                    if node.name == "Lipstick Type":
                        node.outputs[0].default_value = self.LegacyLipstickType  
                    if node.name == "Eyeshadow Color":
                        if self.LegacyEyeshadowColorBool:
                            node.outputs[0].default_value = self.LegacyEyeshadowColor
                        else:
                            node.outputs[0].default_value = (1.,1.,1.,1.) 
                    if node.type == 'GROUP' and "Shader" in node.node_tree.name:
                        for input in node.inputs:
                            if input.name == "Subsurface":
                                input.default_value = self.LegacySubsurface

bpy.types.Object.LegacyTan = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Tan",
                                                            description = "",
                                                            update = LegacyNodes)      

bpy.types.Object.LegacyTanLines = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Tan Lines",
                                                            description = "",
                                                            update = LegacyNodes) 

bpy.types.Object.LegacyScratches = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Scratches",
                                                            description = "",
                                                            update = LegacyNodes)  

bpy.types.Object.LegacyDirt = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Dirt",
                                                            description = "",
                                                            update = LegacyNodes)  

bpy.types.Object.LegacySpanked = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Spanked",
                                                            description = "",
                                                            update = LegacyNodes) 

bpy.types.Object.LegacyOily = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Oily",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyFoam = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Foam",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyWet = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Wet",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacySubsurface = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Subsurface",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyGloss = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Gloss",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacySubsurface = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Subsurface",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyMascaraSmudge = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Mascara Smudge",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyMascaraTears = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Mascara Tears",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyMascaraTearsType = bpy.props.BoolProperty(default = False,
                                                            name = "Mascara Tears Alt Shape",
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyWetSwitch = bpy.props.BoolProperty(default = False,
                                                            name="Wet --> Sweat Swicth",
                                                            description="Unticked=wet ; Ticked = Sweat",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyBlood = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Bloody Mess",
                                                            description = "",
                                                            update = LegacyNodes)
                                                            
                                                            
bpy.types.Object.LegacyVeins = bpy.props.FloatProperty(default = 0.0,
                                                            min = 0.0,
                                                            max = 1.0,
                                                            name = "Veins",
                                                            description = "",
                                                            update = LegacyNodes)

bpy.types.Object.LegacyFingerNailsColorBool = bpy.props.BoolProperty(default = False,
                                                            name = "Finger Nails Color",
                                                            description="custom color for finger nails",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyFingerNailsColor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=LegacyNodes)


bpy.types.Object.LegacyToeNailsColorBool = bpy.props.BoolProperty(default = False,
                                                            name = "Toe Nails Color",
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyToeNailsColor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=LegacyNodes)


bpy.types.Object.LegacyBlushColorBool = bpy.props.BoolProperty(default = False,
                                                            name = "Blush Color",
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyBlushColor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyLipstickColorBool = bpy.props.BoolProperty(default = False,
                                                            name = "Lips Color",
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyLipstickColor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyLipstickType = bpy.props.IntProperty(default = 1,
                                                            min = 1,
                                                            max = 3,
                                                            name = "Lipstick Type",
                                                            description = "",
                                                            update = LegacyNodes) 

bpy.types.Object.LegacyEyeshadowColorBool = bpy.props.BoolProperty(default = False,
                                                            name = "Eyeshadow Color",
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyEyeshadowColor = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=LegacyNodes)

bpy.types.Object.LegacyTanLinesType = bpy.props.IntProperty(default = 1,
                                                            min = 1,
                                                            max = 3,
                                                            name = "Tan Lines Type",
                                                            description = "",
                                                            update = LegacyNodes) 


bpy.types.Object.LegacyGenColor =  bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update= LegacyNodes)

bpy.types.Object.LegacyGenSwellColor =  bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="",
                                                            update=LegacyNodes)


# ------------------------------------------------------------------------
#   Body Morphs
# ------------------------------------------------------------------------


def charbodytypeselect_update(self, context):

    bodytest = bpy.data.objects[bpy.context.scene.model_tools.model_name+' Body']
    
    if self.charbodytype:
        bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig'][bpy.context.scene.model_tools.model_name+' Body Morph'] = 1.0
    else:
        bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig'][bpy.context.scene.model_tools.model_name+' Body Morph'] = 0.0
    return


bpy.types.Armature.charbodytype = bpy.props.BoolProperty(default = True,
                                                            name = "Apply Char's Body Preset",
                                                            description="Apply character's body type",
                                                            update=charbodytypeselect_update)

def lHandFist_update(self, context):
    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['CTRLlFingersFist'] = self.lHandFist
    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['CTRLlThumbFist'] = self.lHandFist
    return

bpy.types.Armature.lHandFist = bpy.props.FloatProperty(min = 0.0, max = 1.0, name = "Left Hand Fist", description = "", update = lHandFist_update)


def rHandFist_update(self, context):
    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['CTRLrFingersFist'] = self.rHandFist
    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['CTRLrThumbFist'] = self.rHandFist
    return

bpy.types.Armature.rHandFist = bpy.props.FloatProperty(min = 0.0, max = 1.0, name = "Right Hand Fist", description = "", update = rHandFist_update)


def lHandGrasp_update(self, context):
    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['CTRLlHandGrasp'] = self.lHandGrasp
    return

bpy.types.Armature.lHandGrasp = bpy.props.FloatProperty(min = 0.0, max = 1.0, name = "Left Hand Grasp", description = "", update = lHandGrasp_update)


def rHandGrasp_update(self, context):
    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['CTRLrHandGrasp'] = self.rHandGrasp
    return

bpy.types.Armature.rHandGrasp = bpy.props.FloatProperty(min = 0.0, max = 1.0, name = "Right Hand Grasp", description = "", update = rHandGrasp_update)



def reapplychar_update(self, context):
    
    if self.reapplychar:
        if bpy.context.scene.model_tools.model_name != "None":
            bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'][bpy.context.scene.model_tools.model_name+' Body Morph'] = 1.0
            bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'][bpy.context.scene.model_tools.model_name+' Head Morph'] = 1.0
            self.reapplychar=0
    return

bpy.types.Armature.reapplychar = bpy.props.BoolProperty(default = False,
                                                            name="Apply Char's morphs",
                                                            description="Apply Char's morphs",
                                                            update = reapplychar_update)                                                            


def removechar_update(self, context):
    
    if self.removechar:
        if bpy.context.scene.model_tools.model_name != "None":
            bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'][bpy.context.scene.model_tools.model_name+' Body Morph'] = 0.0
            bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'][bpy.context.scene.model_tools.model_name+' Head Morph'] = 0.0
            self.removechar=0
    return

bpy.types.Armature.removechar = bpy.props.BoolProperty(default = False,
                                                            name="Remove Char's morphs",
                                                            description="Remove Char's morphs",
                                                            update = removechar_update)     



def earstypeselect_update(self, context):
    
    
    list = ['01','02','03','04','05','06','07','08','09','10','11','12','13','14','15','16','17','18','19','20']
    for number in list:
        if number != str(self.earstypeselect) and number != '0'+str(self.earstypeselect):
            if bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['EJFantasyEars'+number] != 0.0:
                if self.earstypeselect < 10:
                    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['EJFantasyEars0'+str(self.earstypeselect)] = bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['EJFantasyEars'+number]
                else:
                    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['EJFantasyEars'+str(self.earstypeselect)] = bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['EJFantasyEars'+number]
            bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['EJFantasyEars'+number] = 0.0
                      
    return

bpy.types.Object.earstypeselect = bpy.props.IntProperty(default=1, name="", description="", min=1, max=20, update = earstypeselect_update)


def feettypeselect_update(self, context):
    
    
    list = ['1','2','3','4','5','6','7']
    for number in list:
        if number != str(self.feettypeselect):
            if bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['Real Feet '+number] != 0.0:
                bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['Real Feet '+str(self.feettypeselect)] = bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['Real Feet '+number]
            bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['Real Feet '+number] = 0.0
                      
    return

bpy.types.Object.feettypeselect = bpy.props.IntProperty(default=1, name="", description="", min=1, max=7, update = feettypeselect_update)

def genstypeselect_update(self, context):
    
    list = ['01','02','03']
    for number in list:
        if number != '0'+str(self.genstypeselect):
            if bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['PBMGensClose'+number] != 0.0:
                bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['PBMGensClose0'+str(self.genstypeselect)] = bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['PBMGensClose'+number]
            bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']['PBMGensClose'+number] = 0.0
    return

bpy.types.Object.genstypeselect = bpy.props.IntProperty(default=1, name="", description="", min=1, max=3, update = genstypeselect_update)



# ------------------------------------------------------------------------
#    Rig Properties
# ------------------------------------------------------------------------

                                                
def showIK_update(self, context):
    
    if bpy.context.scene.model_tools.model_name != "None":
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data
 
        if self.showIK:
            armature.layers[26] = True
            armature.layers[27] = True
            armature.layers[28] = True
            armature.layers[29] = True
        else:
            armature.layers[26] = False
            armature.layers[27] = False
            armature.layers[28] = False
            armature.layers[29] = False
        return

bpy.types.Object.showIK = bpy.props.BoolProperty(default = False,
                                                            name="IK",
                                                            description="Show/hide",
                                                            update = showIK_update) 


def showFK_update(self, context):
    
    if bpy.context.scene.model_tools.model_name != "None":
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data
 
        if self.showFK:
            armature.layers[18] = True
            armature.layers[19] = True
            armature.layers[20] = True
            armature.layers[21] = True
        else:
            armature.layers[18] = False
            armature.layers[19] = False
            armature.layers[20] = False
            armature.layers[21] = False
        return

bpy.types.Object.showFK = bpy.props.BoolProperty(default = False,
                                                            name="FK",
                                                            description="Show/hide",
                                                            update = showFK_update) 



    #-------------------------------------------------------------
    #   Simple IK
    #-------------------------------------------------------------

BoneLayers = {
    "Spine" : 16,
    "Face" : 17,
    "Left FK Arm" : 18,
    "Right FK Arm" : 19,
    "Left FK Leg" : 20,
    "Right FK Leg" : 21,
    "Left Hand" : 22,
    "Right Hand" : 23,
    "Left Foot" : 24,
    "Right Foot" : 25,
    "Left IK Arm" : 26,
    "Right IK Arm" : 27,
    "Left IK Leg" : 28,
    "Right IK Leg" : 29,
}

class SimpleIK:
    
    G38Arm = ["ShldrBend", "ShldrTwist", "ForearmBend", "ForearmTwist", "Hand"]
    G38Leg = ["ThighBend", "ThighTwist", "Shin", "Foot"]
    G38Spine = ["hip", "abdomenLower", "abdomenUpper", "chestLower", "chestUpper"]
    G38Neck = ["neckLower", "neckUpper"]
    G12Arm = ["Shldr", "ForeArm", "Hand"]
    G12Leg = ["Thigh", "Shin", "Foot"]
    G12Spine = ["hip", "abdomen", "abdomen2", "spine", "chest"]
    G12Neck = ["neck"]



    def getIKProp(self, prefix, type):
        return "Daz" + type + "IK_" + prefix.upper()



    def getLimbBoneNames(self, rig, prefix, type):
        genesis = "G38"
        if not genesis:
            return None
        table = getattr(self, genesis+type)
        return [prefix+bname for bname in table]



    #----------------------------------------------------------
    #   FK Snap
    #----------------------------------------------------------

class DAZ_OT_SnapSimpleFK(bpy.types.Operator, SimpleIK):
    bl_idname = "ops.snap_simple_fk"
    bl_label = "Snap FK"
    bl_description = "Snap FK bones to IK bones"
    bl_options = {'UNDO'}

    prefix : StringProperty()
    type : StringProperty()

    def execute(self, context):
        rig = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']
        bnames = self.getLimbBoneNames(rig, self.prefix, self.type)
        if bnames:
            prop = self.getIKProp(self.prefix, self.type)
            snapSimpleFK(rig, bnames, prop)
            toggleLayer(rig, "FK", self.prefix, self.type, True)
            toggleLayer(rig, "IK", self.prefix, self.type, False)
        return {'FINISHED'}

def snapSimpleFK(rig, bnames, prop):
    mats = []
    for bname in bnames:
        pb = rig.pose.bones[bname]
        mats.append((pb, pb.matrix.copy()))
    setattr(rig, prop, False)
    for pb,mat in mats:
        pb.matrix = mat

    #----------------------------------------------------------
    #   IK Snap
    #----------------------------------------------------------

class DAZ_OT_SnapSimpleIK(bpy.types.Operator, SimpleIK):
    bl_idname = "ops.snap_simple_ik"
    bl_label = "Snap IK"
    bl_description = "Snap IK bones to FK bones"
    bl_options = {'UNDO'}

    prefix : StringProperty()
    type : StringProperty()

    def execute(self, context):
        rig = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']
        bnames = self.getLimbBoneNames(rig, self.prefix, self.type)
        if bnames:
            prop = self.getIKProp(self.prefix, self.type)
            snapSimpleIK(rig, bnames, prop)
            toggleLayer(rig, "FK", self.prefix, self.type, False)
            toggleLayer(rig, "IK", self.prefix, self.type, True)
        return {'FINISHED'}

def snapSimpleIK(rig, bnames, prop):
    hand = bnames[-1]
    handfk = rig.pose.bones[hand]
    mat = handfk.matrix.copy()
    handik = rig.pose.bones[hand+"IK"]
    setattr(rig, prop, True)
    handik.matrix = mat


def toggleLayer(rig, fk, prefix, type, on):
    side = {"l" : "Left", "r" : "Right"}
    lname = ("%s %s %s" % (side[prefix], fk, type))
    layer = BoneLayers[lname]
    rig.data.layers[layer] = on

    #----------------------------------------------------------
    #   IK/FK Toggles
    #----------------------------------------------------------


class toggle_ik (bpy.types.Operator):
    bl_idname = "ops.toggle_ik"
    bl_label = "Toggle IK"
    bl_description = "Toggles IK"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools
        armature=bpy.data.objects[model_tools.model_name+'_rig']
        if model_tools.model_name != "None":
            if not bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode:
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Arm")
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Leg")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 1
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 1
                armature.pose.bones["rShin"].constraints["IK"].influence = 1
                armature.pose.bones["lShin"].constraints["IK"].influence = 1
            else:
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=False
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Arm")
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Leg")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 1
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 1
                armature.pose.bones["rShin"].constraints["IK"].influence = 1
                armature.pose.bones["lShin"].constraints["IK"].influence = 1 
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=True                              

        return {'FINISHED'}  

class toggle_ik_arms (bpy.types.Operator):
    bl_idname = "ops.toggle_ik_arms"
    bl_label = "Toggle IK Arms"
    bl_description = "Toggles IK Arms"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        armature=bpy.data.objects[model_tools.model_name+'_rig']
        if model_tools.model_name != "None":
            if not bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode:
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Arm")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 1
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 1
            else:
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=False
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Arm")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 1
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 1
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=True    
        return {'FINISHED'}  

class toggle_ik_legs (bpy.types.Operator):
    bl_idname = "ops.toggle_ik_legs"
    bl_label = "Toggle IK Legs"
    bl_description = "Toggles IK Legs"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        armature=bpy.data.objects[model_tools.model_name+'_rig']
        if model_tools.model_name != "None":
            if not bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode:
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Leg")
                armature.pose.bones["rShin"].constraints["IK"].influence = 1
                armature.pose.bones["lShin"].constraints["IK"].influence = 1
            else:
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=False
                bpy.ops.ops.snap_simple_ik(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_ik(prefix="r", type="Leg")
                armature.pose.bones["rShin"].constraints["IK"].influence = 1
                armature.pose.bones["lShin"].constraints["IK"].influence = 1 
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=True  
        return {'FINISHED'} 

class toggle_fk (bpy.types.Operator):
    bl_idname = "ops.toggle_fk"
    bl_label = "Toggle FK"
    bl_description = "Toggles FK"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        armature=bpy.data.objects[model_tools.model_name+'_rig']
        if model_tools.model_name != "None":
            if not bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode:
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Arm")
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Leg")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 0
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 0
                armature.pose.bones["rShin"].constraints["IK"].influence = 0
                armature.pose.bones["lShin"].constraints["IK"].influence = 0
            else:
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=False
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Arm")
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Leg")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 0
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 0
                armature.pose.bones["rShin"].constraints["IK"].influence = 0
                armature.pose.bones["lShin"].constraints["IK"].influence = 0
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=True
        return {'FINISHED'}  

class toggle_fk_arms (bpy.types.Operator):
    bl_idname = "ops.toggle_fk_arms"
    bl_label = "Toggle FK Arms"
    bl_description = "Toggles FK Arms"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        armature=bpy.data.objects[model_tools.model_name+'_rig']
        if model_tools.model_name != "None":
            if not bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode:
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Arm")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 0
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 0
            else:
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=False
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Arm")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Arm")
                armature.pose.bones["rForearmTwist"].constraints["IK"].influence = 0
                armature.pose.bones["lForearmTwist"].constraints["IK"].influence = 0
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=True
        return {'FINISHED'}  
    
class toggle_fk_legs (bpy.types.Operator):
    bl_idname = "ops.toggle_fk_legs"
    bl_label = "Toggle FK Legs"
    bl_description = "Toggles FK Legs"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        armature=bpy.data.objects[model_tools.model_name+'_rig']
        if model_tools.model_name != "None":
            if not bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode:
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Leg")
                armature.pose.bones["rShin"].constraints["IK"].influence = 0
                armature.pose.bones["lShin"].constraints["IK"].influence = 0
            else:
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=False
                bpy.ops.ops.snap_simple_fk(prefix="l", type="Leg")
                bpy.ops.ops.snap_simple_fk(prefix="r", type="Leg")
                armature.pose.bones["rShin"].constraints["IK"].influence = 0
                armature.pose.bones["lShin"].constraints["IK"].influence = 0
                bpy.data.objects[model_tools.model_name+ ' Body'].mirrormode=True
        return {'FINISHED'}  


def kneemode_update(self, context): 
    if bpy.context.scene.model_tools.model_name != "None":
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']
        if not self.mirrormode:
            if self.kneemode:
                armature.pose.bones["lKnee"].constraints["Armature"].mute = False
                armature.pose.bones["rKnee"].constraints["Armature"].mute = False
            else:
                armature.pose.bones["lKnee"].constraints["Armature"].mute = True
                armature.pose.bones["rKnee"].constraints["Armature"].mute = True
        else:
            if self.kneemode:
                armature.pose.bones["Knee.L"].constraints["Armature"].mute = False
                armature.pose.bones["Knee.R"].constraints["Armature"].mute = False
            else:
                armature.pose.bones["Knee.L"].constraints["Armature"].mute = True
                armature.pose.bones["Knee.R"].constraints["Armature"].mute = True            
    return

bpy.types.Object.kneemode = bpy.props.BoolProperty(default = False,
                                                            name="Knees Follow Feet",
                                                            description="",
                                                            update = kneemode_update)   


def elbowmode_update(self, context): 
    if bpy.context.scene.model_tools.model_name != "None":
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']
        if not self.mirrormode:
            if self.elbowmode:
                armature.pose.bones["lElbow"].constraints["Armature"].mute = False
                armature.pose.bones["rElbow"].constraints["Armature"].mute = False
            else:
                armature.pose.bones["lElbow"].constraints["Armature"].mute = True
                armature.pose.bones["rElbow"].constraints["Armature"].mute = True
        else:
            if self.elbowmode:
                armature.pose.bones["Elbow.L"].constraints["Armature"].mute = False
                armature.pose.bones["Elbow.R"].constraints["Armature"].mute = False
            else:
                armature.pose.bones["Elbow.L"].constraints["Armature"].mute = True
                armature.pose.bones["Elbow.R"].constraints["Armature"].mute = True
    return

bpy.types.Object.elbowmode = bpy.props.BoolProperty(default = False,
                                                            name="Elbows Follow Hands",
                                                            description="",
                                                            update = elbowmode_update)                                                              

def gazemode_update(self, context): 
    if bpy.context.scene.model_tools.model_name != "None":
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']
        if not self.mirrormode:
            if self.gazemode:
                armature.pose.bones["lEye"].constraints["Damped Track"].mute = False
                armature.pose.bones["rEye"].constraints["Damped Track"].mute = False
            else:
                armature.pose.bones["lEye"].constraints["Damped Track"].mute = True
                armature.pose.bones["rEye"].constraints["Damped Track"].mute = True

        else:
            if self.gazemode:
                armature.pose.bones["Eye.L"].constraints["Damped Track"].mute = False
                armature.pose.bones["Eye.R"].constraints["Damped Track"].mute = False
            else:
                armature.pose.bones["Eye.L"].constraints["Damped Track"].mute = True
                armature.pose.bones["Eye.R"].constraints["Damped Track"].mute = True
    return

bpy.types.Object.gazemode = bpy.props.BoolProperty(default = False,
                                                            name="Eyes Follow Gaze",
                                                            description="",
                                                            update = gazemode_update)   


def mirrormode_update(self, context): 
    if bpy.context.scene.model_tools.model_name != "None":
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']
        if self.mirrormode:
            for b in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data.bones:
                if "Butt" not in b.name and "Middle" not in b.name and "Below" not in b.name and "gaze" not in b.name:
                    if b.name.startswith('l'):
                        b.name = b.name[1:]
                        b.name = b.name+'.L'
                    if b.name.startswith('r'):
                        b.name = b.name[1:]
                        b.name = b.name+'.R'
            armature.pose.use_mirror_x = 1
        else:
            for b in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data.bones:
                if "Butt" not in b.name and "Middle" not in b.name and "Below" not in b.name and "gaze" not in b.name:
                    if b.name.endswith('.L'):
                        b.name = 'l'+b.name.replace('.L','')
                    if b.name.endswith('.R'):
                        b.name = 'r'+b.name.replace('.R','')
            armature.pose.use_mirror_x = 0
        return

bpy.types.Object.mirrormode = bpy.props.BoolProperty(default = False,
                                                            name="",
                                                            description="This will hide some features that don't work when it's on",
                                                            update = mirrormode_update) 



def genssizeselect_update(self, context): 
    if bpy.context.scene.model_tools.model_name != "None":    
        armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'] 
        bpy.ops.object.mode_set(mode='OBJECT')
        bpy.ops.object.select_all(action='DESELECT')

        armature.select_set(True)
        bpy.context.view_layer.objects.active = armature
        bpy.ops.object.mode_set(mode='POSE')
        name = "Gens Size"
        action = bpy.data.actions.get(name)
        armature.pose_library = action
        GensSizeList = ['Default', 'Big', 'Bigger', 'Biggest']
        for bone in armature.data.bones:
            bone.select = False
        

        for i in range(len(GensSizeList)):
            if GensSizeList[i] == self.genssizemenu:
                bpy.ops.poselib.apply_pose(pose_index=i)    
    return

bpy.types.Object.genssizemenu = bpy.props.EnumProperty(name="", description="", items=[('Default', "Default Size", ''), ('Big', "Big Size", ''), ('Bigger', "Bigger Size", ''), ('Biggest', "Biggest Size", '')], 
                                                    update = genssizeselect_update)
                                                           
# ------------------------------------------------------------------------
#    Hair Properties
# ------------------------------------------------------------------------

bpy.types.Object.additional_subdiv_hair = bpy.props.BoolProperty(name="",default=False, description="Show subdiv options")



def haircolor_update(self, context):

    if bpy.context.scene.model_tools.model_name != "None":
        if bpy.context.scene.model_tools.hair_name != "Bald":
            for mat in bpy.data.objects[bpy.context.scene.model_tools.hair_name].data.materials:
                if mat != None and mat.use_nodes:
                    for node in mat.node_tree.nodes:
                        if node.type == 'GROUP' and "Hair Color" in node.node_tree.name:
                            node.inputs[0].default_value = self.custom_hair_color
                            node.inputs[2].default_value = self.hair_color
                        if node.name == "Hair Tweak":
                            node.outputs[0].default_value = self.custom_hair_color
                        if node.name == "Hair Color":
                            node.outputs[0].default_value = self.hair_color

    return
        
bpy.types.Object.custom_hair_color = bpy.props.BoolProperty(update=haircolor_update)
                                                            
bpy.types.Object.hair_color = bpy.props.FloatVectorProperty(name = "",
                                                            subtype='COLOR_GAMMA',
                                                            default=(1.,1.,1.,1.),
                                                            size=4,
                                                            min=0.0,
                                                            max=1.0,
                                                            description="Set the hair color",
                                                            update=haircolor_update)


# ------------------------------------------------------------------------
#    Outfit Properties
# ------------------------------------------------------------------------

bpy.types.Collection.additional_subdiv = bpy.props.BoolProperty(name="",default=False, description="Show subdiv options")
bpy.types.Collection.additional_subdiv_extras = bpy.props.BoolProperty(name="",default=False, description="Show subdiv options")
bpy.types.Collection.additional_texture_outfit = bpy.props.BoolProperty(name="",default=False, description="Show texture options")
bpy.types.Collection.additional_texture_extras = bpy.props.BoolProperty(name="",default=False, description="Show texture options")
bpy.types.Object.additional_options_show = bpy.props.BoolProperty(name="",default=False, description="Show texture options")


def outfit_text_count():
    OutfitText=0
    OutfitAltText=0
    if bpy.context.scene.model_tools.model_name != "None":
        if bpy.context.scene.model_tools.outfit_name != "Nude":
            for ob in bpy.data.collections[bpy.context.scene.model_tools.outfit_name].objects:
                if ob.type == 'MESH':        
                    for mat in ob.data.materials:
                        if mat != None and mat.use_nodes:
                            for node in mat.node_tree.nodes:
                                if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                                    if not OutfitAltText:
                                        for input in node.inputs:
                                            if input.links and input.type == 'RGBA':
                                                OutfitText=OutfitText+1
                                    OutfitAltText=OutfitAltText+1
        return(OutfitText)
    else:
        return 0

            
def outfit_text_update(self, context):

    if bpy.context.scene.model_tools.model_name != "None": 
        for obj in bpy.data.collections[bpy.context.scene.model_tools.outfit_name].objects:  
            if obj.type == 'MESH':
                for mat in obj.data.materials:
                    if mat != None and mat.use_nodes:
                        for node in mat.node_tree.nodes:
                            if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                                for input in node.inputs:
                                    if input.name == "Texture Number" and input.type == 'INT' and not input.links:
                                        input.default_value = self.outfittext
                                    elif input.name == "Texture Number" and input.type == 'VALUE' and input.links:
                                        if type(input.links[0].from_node) is bpy.types.ShaderNodeValue:
                                            mat.node_tree.nodes[input.links[0].from_node.name].outputs[0].default_value = self.outfittext
                                    elif input.name == "Texture Number" and input.type == 'VALUE':
                                        input.default_value = self.outfittext
    return


bpy.types.Object.outfittext = bpy.props.IntProperty(default = 1,
                                                            min = 1,
                                                            max = 14,
                                                            name = "",
                                                            description = "Outfit Texture Selection",
                                                            update = outfit_text_update)         



def outfit_show(self, context):

    
    if self.outfit_visibility:# or self.outfit_lock:
        self.hide_viewport = False
        self.hide_render = False
        if self.parent and self.parent != bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
            self.parent.hide_viewport = False
            self.parent.hide_render = False
    else:
        self.hide_viewport = True
        self.hide_render = True
        if self.parent and self.parent != bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
            self.parent.hide_viewport = True
            self.parent.hide_render = True    
    return

bpy.types.Object.outfit_visibility = bpy.props.BoolProperty(default = True,
                                                        name="",
                                                        description="",
                                                        update = outfit_show)

def heelsmodeselect_update(self, context): 
    armature = bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig'] 
    bpy.ops.object.mode_set(mode='OBJECT')
    bpy.ops.object.select_all(action='DESELECT')

    bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig'].select_set(True)
    bpy.context.view_layer.objects.active = armature 
    bpy.ops.object.mode_set(mode='POSE')

    HeelsList = ['Zeroed Feet', 'HighHeels', 'MediumHeels', 'LowHeels', 'TipToes']
    FootX = [0,1.13446,0.645772,0.50091,1.13446]
    ToeX = [0,-1.12748,-0.612611,-0.446804,0.260054]
    RToeY = [0,0,-0.0509636,-0.00335103,-0.114145]
 
    for bone in bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig'].data.bones:
        bone.select = False
    

    for i in range(len(HeelsList)):
        if HeelsList[i] == self.heelsmodeselect:
            if not bpy.data.objects[bpy.context.scene.model_tools.model_name+' Body'].mirrormode :
                if armature.pose.bones["lFoot"].constraints["Copy Rotation"].influence == 1 and armature.pose.bones["rFoot"].constraints["Copy Rotation"].influence == 1:
                    bpy.ops.ops.snap_simple_fk(prefix="l", type="Leg")
                    bpy.ops.ops.snap_simple_fk(prefix="r", type="Leg")
                    armature.pose.bones["lFoot"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["rFoot"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["lToe"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["rToe"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["lToe"].rotation_euler[1] = -RToeY[i]
                    armature.pose.bones["rToe"].rotation_euler[1] = RToeY[i]
                    bpy.ops.ops.snap_simple_ik(prefix="l", type="Leg")
                    bpy.ops.ops.snap_simple_ik(prefix="r", type="Leg")
                else:
                    armature.pose.bones["lFoot"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["rFoot"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["lToe"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["rToe"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["lToe"].rotation_euler[1] = -RToeY[i]
                    armature.pose.bones["rToe"].rotation_euler[1] = RToeY[i]    
            else:
                if armature.pose.bones["Foot.L"].constraints["Copy Rotation"].influence == 1 and armature.pose.bones["Foot.R"].constraints["Copy Rotation"].influence == 1:                    
                    bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mirrormode=False
                    bpy.ops.ops.snap_simple_fk(prefix="l", type="Leg")
                    bpy.ops.ops.snap_simple_fk(prefix="r", type="Leg")
                    armature.pose.bones["lFoot"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["rFoot"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["lToe"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["rToe"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["lToe"].rotation_euler[1] = -RToeY[i]
                    armature.pose.bones["rToe"].rotation_euler[1] = RToeY[i]
                    bpy.ops.ops.snap_simple_ik(prefix="l", type="Leg")
                    bpy.ops.ops.snap_simple_ik(prefix="r", type="Leg") 
                    bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mirrormode=True 
                else:
                    armature.pose.bones["Foot.L"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["Foot.R"].rotation_euler[0] = FootX[i]
                    armature.pose.bones["Toe.L"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["Toe.R"].rotation_euler[0] = ToeX[i]
                    armature.pose.bones["Toe.L"].rotation_euler[1] = -RToeY[i]
                    armature.pose.bones["Toe.R"].rotation_euler[1] = RToeY[i]          
    return

bpy.types.Object.heelsmodeselect = bpy.props.EnumProperty(name="", description="", items=[('Zeroed Feet', "Default", ''), ('HighHeels', "High Heels", ''), ('MediumHeels', "Medium Heels", ''), ('LowHeels', "Low Heels", ''), ('TipToes', "Ballet", '')], 
                                                    update = heelsmodeselect_update)


def additional_options_test(object):
    list=[]
    if object.data.materials:
        for mat in object.data.materials:
            if mat != None and mat.use_nodes:
                for node in mat.node_tree.nodes:
                    if "UI - " in node.name or "UI Bool - " in node.name or "UI Float - " in node.name:
                        if mat not in list:
                            list.append(mat)                
    return list

def additional_morph_options_test(object):
    list=[]
    if object.data.shape_keys:
        for shape_key in object.data.shape_keys.key_blocks:
            if "UI - " in shape_key.name or "UI Float - " in shape_key.name:
                list.append(shape_key)
    return list

def additional_mask_options_test(object):
    list=[]
    if object.modifiers:
        for modifier in object.modifiers:
            if "UI - " in modifier.name and modifier.type == 'MASK':
                list.append(modifier)
    return list


def custom_bool_prop_update(self,context):
    if self.custom_bool_prop:
        if self.type == 'VALUE':
            self.outputs[0].default_value = 1
        elif self.type == 'GROUP':
            for input in self.inputs:
                if input.type == 'VALUE':
                    input.default_value = 1
    else:
        if self.type == 'VALUE':
            self.outputs[0].default_value = 0
        elif self.type == 'GROUP':
            for input in self.inputs:
                if input.type == 'VALUE':
                    input.default_value = 0        
            

bpy.types.Node.custom_bool_prop = bpy.props.BoolProperty(name="",
                                                            description="",
                                                            update = custom_bool_prop_update) 

def custom_float_prop_update(self,context):
    if self.type == 'VALUE' and "UI Float - " in self.name:
        self.outputs[0].default_value = self.custom_float_prop


bpy.types.Node.custom_float_prop = bpy.props.FloatProperty(name="",
                                            min=0.,max=1.,
                                            update=custom_float_prop_update,
                                            description="")

# ------------------------------------------------------------------------
#    Fixes
# ------------------------------------------------------------------------

class fix_IK (bpy.types.Operator):
    bl_idname = "ops.fix_ik"
    bl_label = "Fix IK"
    bl_description = "Fixes loops dependencies in rig"

    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        if model_tools.model_name != "None":
            for bone in bpy.data.objects[model_tools.model_name+'_rig'].pose.bones:
                if "Elbow" in bone.name or "Knee" in bone.name:
                    if bone.constraints:
                        for con in bone.constraints:
                            if con.type == 'ARMATURE':
                                if con.targets[0].subtarget == "lHand":
                                    con.targets[0].subtarget = "lHandIK"
                                if con.targets[0].subtarget == "rHand":
                                    con.targets[0].subtarget = "rHandIK"
                                if con.targets[0].subtarget == "lFoot":
                                    con.targets[0].subtarget = "lFootIK"                                    
                                if con.targets[0].subtarget == "rFoot":
                                    con.targets[0].subtarget = "rFootIK"
        return {'FINISHED'}       

class fix_hip_locked (bpy.types.Operator):
    bl_idname = "ops.fix_hip_locked"
    bl_label = "Fix Hip Locked"
    bl_description = "Removes driver on hip"
    
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        if model_tools.model_name != "None":
            bpy.data.objects[model_tools.model_name+'_rig'].pose.bones["hip"].driver_remove('location')
 
        return {'FINISHED'}  


class remove_drivers (bpy.types.Operator):
    bl_idname = "ops.remove_drivers"
    bl_label = "Remove drivers"
    bl_description = "Removes drivers from current object"
    
        
    def execute(self, context):
        scene = context.scene
        model_tools = scene.model_tools 
        armature = bpy.context.view_layer.objects.active
        if armature.animation_data:
            armature.animation_data_clear()
                
        if armature.data.animation_data:
            armature.data.animation_data_clear()
 
        return {'FINISHED'}  


class clean_invalid_drivers (bpy.types.Operator):
    bl_idname = "ops.clean_invalid_drivers"
    bl_label = "Clean drivers"
    bl_description = "Cleans invalid drivers"
    
        
    def execute(self, context):
        for sk in bpy.data.shape_keys:
            if not sk.animation_data:
                continue
            bung_drivers = []
            # find bung drivers
            for d in sk.animation_data.drivers:
                try:
                    sk.path_resolve(d.data_path)
                except ValueError:
                    bung_drivers.append(d)
            # remove bung drivers
            while bung_drivers:
                sk.animation_data.drivers.remove(
                bung_drivers.pop()
                )
        return {'FINISHED'}  


class remove_obj_custom_properties (bpy.types.Operator):
    bl_idname = "ops.remove_obj_custom_properties"
    bl_label = "Remove Properties"
    bl_description = "Removes All Custom Properties For Selected Object"
    
        
    def execute(self, context):
        obj = bpy.context.view_layer.objects.active.name    
        props = [*bpy.data.objects[obj].keys()]  # Retrieve custom props names
        for prop in props:
             del bpy.data.objects[obj][prop]
        return {'FINISHED'} 


class remove_rig_custom_properties (bpy.types.Operator):
    bl_idname = "ops.remove_rig_custom_properties"
    bl_label = "Remove Properties"
    bl_description = "Removes All Custom Properties For Selected Armature"
    
        
    def execute(self, context):
        armature = bpy.context.view_layer.objects.active.name    

        props = [*bpy.data.armatures[armature].keys()]  # Retrieve custom props names
        for prop in props:
             del bpy.data.armatures[armature][prop]
        return {'FINISHED'} 

# ------------------------------------------------------------------------
#    Tools
# ------------------------------------------------------------------------


# ------------------------------------------------------------------------
#    Tools - Parent
# ------------------------------------------------------------------------

bpy.types.Object.childof_contr_name = bpy.props.StringProperty(default = 'ChildOf')

@classmethod
def childof_poll(cls, context):
    arm = bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig']

class ChildOf(bpy.types.Operator):
    """Apply Child Of modifier"""
    bl_idname = "ops.childof"
    bl_label = "Apply Child Of modifier"
    bl_options = {'REGISTER'}
    
    clean: IntProperty(name='CLEAN',
        description="Clean action",
        default=0
    )

    def execute(self, context):
        
        arm = bpy.data.objects[bpy.context.scene.model_tools.model_name+'_rig']
        arm2 = bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig']
        
        if self.clean==0:
        
            ob = bpy.context.active_object
        
            if len(bpy.context.selected_pose_bones)==2:
                
                if bpy.context.selected_pose_bones[0].id_data == bpy.context.selected_pose_bones[1].id_data:
                    parent_bone = bpy.context.selected_pose_bones[0]
                    child_bone = bpy.context.selected_pose_bones[1]
                else:
                    parent_bone = bpy.context.selected_pose_bones[1]
                    child_bone = bpy.context.selected_pose_bones[0]
                
                if ob == child_bone.id_data:
        
                    constr = child_bone.constraints.new('CHILD_OF')
                    constr.name = arm2.childof_contr_name
        
                    constr.target = parent_bone.id_data
                    constr.subtarget = parent_bone.name
            
                    context_py = bpy.context.copy()
                    context_py["constraint"] = constr
            
                    org_layers = ob.data.layers[:]
                    for i in range(len(org_layers)):
                        ob.data.layers[i] = True
            
                    ob.data.bones.active = child_bone.id_data.pose.bones[child_bone.name].bone
                    bpy.ops.constraint.childof_set_inverse(context_py, constraint=constr.name, owner='BONE')
            
                    for i in range(len(org_layers)):
                        ob.data.layers[i] = org_layers[i]
        
                    constr.influence = bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig'].childof_influence
                    
                    self.report({'INFO'}, 'The two selected Bones has been parented.')
        
                else:
                    self.report({'ERROR'}, 'You should select two Bones. No modifier has been added.')
                
            else:
                self.report({'ERROR'}, 'You should select two Bones. No modifier has been added.')
        
        else:
            
            mod_cont = 0
            for obj in bpy.data.objects:
                if obj.type=="ARMATURE":
                    for bone in obj.pose.bones:
                        for constr in bone.constraints:
                            if arm2.childof_contr_name in constr.name:
                                bone.constraints.remove(constr)
                                print('Constraint of '+bone.name+' in '+obj.name+' successfully removed.')
                                mod_cont=mod_cont+1
            
            if mod_cont>0:
                self.report({'INFO'}, str(mod_cont)+" modifiers successfully removed.")
            else:
                self.report({'INFO'}, 'No modifier was found. None was removed.')
        
        return {'FINISHED'}

bpy.types.Armature.childof_influence = bpy.props.FloatProperty(default = 1.0,
                                                        min = 0.0,
                                                        max = 1.0,
                                                        name = "Influence",
                                                        description = "Set the influence the parent Bone will have on the Child one")


# ------------------------------------------------------------------------
#    Link (thanks to Mets3D)
# ------------------------------------------------------------------------

class Link_Button(bpy.types.Operator):
    """Open links in a web browser"""
    bl_idname = "ops.open_link"
    bl_label = "Open Link in web browser"
    bl_options = {'REGISTER'}
    
    url: StringProperty(name='URL',
        description="URL",
        default="http://blender.org/"
    )

    def execute(self, context):
        webbrowser.open_new(self.url) # opens in default browser
        return {'FINISHED'}


# ------------------------------------------------------------------------
#    UI
# ------------------------------------------------------------------------

class MainPanel:
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = "LeGuymelef UI"
#    bl_options = {"DEFAULT_CLOSED"}

class LEGUYMELEFUNIFIEDUI_PT_ModelSelection(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_ModelSelection"
    bl_label = "Model Selection"

    def draw(self, context):
        layout = self.layout
        layout.prop(bpy.context.scene.model_tools, "model_name")

class LEGUYMELEFUNIFIEDUI_PT_Engine(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Engine"
    bl_label = "Engine & Performance"

    def draw(self, context):
        layout = self.layout
  

class LEGUYMELEFUNIFIEDUI_PT_ModelEngine(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Engine"
    bl_label = ""


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Model Engine", icon="BLENDER") 

    def draw(self, context):
        
        layout = self.layout
        row = layout.row(align=True)
        row.prop(bpy.context.scene, "engine_cycles",toggle=True, text="Cycles")
        row.prop(bpy.context.scene, "engine_eevee",toggle=True, text="Eevee")

class LEGUYMELEFUNIFIEDUI_PT_Performance(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Engine"
    bl_label = ""

    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Performance", icon="MODIFIER_ON")


    def draw(self, context):
        layout = self.layout        

        row = layout.row(align=True)
        row.label(text="Use Simplify")
        row = layout.row(align=True)
        row.prop(bpy.context.scene.render, "use_simplify",text="")
        row.prop(bpy.context.scene.render, "simplify_subdivision", text="Viewport")
        row.prop(bpy.context.scene.render, "simplify_subdivision_render", text="Render")
        row = layout.row(align=True)
    
        if bpy.context.scene.model_tools.model_name != "None":
            if bpy.data.objects[bpy.context.scene.model_tools.model_name+' Body'].modifiers:
                for modifier in bpy.data.objects[bpy.context.scene.model_tools.model_name+' Body'].modifiers:
                    if modifier.type == "MULTIRES":
                        row = layout.row(align=True)
                        row.label(text="Model Multires")
                        row = layout.row(align=True)
                        row.prop(modifier, "show_viewport", text="")
                        row.prop(modifier,"show_render", text="")
                        row.prop(modifier, "levels", text="Viewport")
                        row.prop(modifier,"render_levels", text="Render")        
                        row = layout.row(align=True)
                        if modifier.show_viewport and modifier.levels > 0:
                            if bpy.context.scene.render.use_simplify == True and bpy.context.scene.render.simplify_subdivision == 0:
                                row.label(text="No effect because of Simplify", icon = "QUESTION")
                                row = layout.row(align=True)
                    if modifier.type == "SUBSURF":
                        row = layout.row(align=True)
                        row.label(text="Model Subdivision")
                        row = layout.row(align=True)
                        row.prop(modifier, "show_viewport", text="")
                        row.prop(modifier,"show_render", text="")
                        row.prop(modifier, "levels", text="Viewport")
                        row.prop(modifier,"render_levels", text="Render")        
                        row = layout.row(align=True)
                        if modifier.show_viewport and modifier.levels > 0:
                            if bpy.context.scene.render.use_simplify == True and bpy.context.scene.render.simplify_subdivision == 0:
                                row.label(text="No effect because of Simplify", icon = "QUESTION")
                                row = layout.row(align=True)
    

        row.label(text="Other perf tools")
        if bpy.context.scene.model_tools.model_name != "None":
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "mannequinmode",toggle=True, text="Mannequin Mode (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mannequinmode else "Mannequin Mode (Off)", icon="ARMATURE_DATA")
        
        row = layout.row(align=True)
        row.operator("daz.disable_drivers")
        row.operator("daz.enable_drivers")
        



class LEGUYMELEFUNIFIEDUI_PT_Model(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = "Body Settings"

    def draw(self, context):
        layout = self.layout

class LEGUYMELEFUNIFIEDUI_PT_Model_SkinProperties(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}

    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Skin Properties", icon="EXPERIMENTAL")

   
    def draw(self, context):
        
        layout = self.layout
        if bpy.context.scene.model_tools.model_name != "None": 
            if BodyTextCount() > 0:
                layout.label(text="Alt body textures found : "+str(BodyTextCount()))
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "body_alt_text", text="Body Texture Select")  

            if EyesTextCount() > 0:
                layout.label(text="Alt eye textures found : "+str(EyesTextCount()))
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "eyes_alt_text", text="Eyes Texture Select")        

            if not DirtNode():                
                if ShaderNode(TorsoMat()).inputs[3].name == "Subsurface":
                    layout.prop(ShaderNode(TorsoMat()).inputs[3], "default_value", text="Subsurface", slider=True)
                if BumpNode():
                    layout.prop(ShaderNode(TorsoMat()).inputs[19], "default_value", text="Bump Global Amount", slider=True)        
                layout.prop(SkinDetailsNode().inputs[1], "default_value", text="Micro Skin Details 01", slider=True)
                if BumpNode():
                    layout.prop(BumpNode().inputs[1], "default_value", text="Micro Skin Details 02", slider=True)
                    layout.prop(BumpNode().inputs[2], "default_value", text="Micro Skin Details 03", slider=True)
                if SpecularDetailsNode():
                    layout.prop(SpecularDetailsNode().inputs[2], "default_value", text="Wet", slider=True)
                layout.prop(ShaderNode(TorsoMat()).inputs[8], "default_value", text="Oily")
                layout.prop(TorsoMakeupNode().inputs[5], "default_value", text="Tan",slider=True)
                layout.prop(TorsoMakeupNode().inputs[6], "default_value", text="TanLines",slider=True)
                layout.prop(TorsoMakeupNode().inputs[7], "default_value", text="TanLinesType")
                layout.prop(TorsoMakeupNode().inputs[3], "default_value", text="Scratches",slider=True)
                layout.prop(TorsoMakeupNode().inputs[8], "default_value", text="Spanked",slider=True)
                layout.prop(TorsoMakeupNode().inputs[4], "default_value", text="Dirt",slider=True)
                layout.prop(TorsoMakeupNode().inputs[12], "default_value", text="Foam",slider=True)
                layout.prop(TorsoMakeupNode().inputs[9], "default_value", text="Bloody Mess",slider=True)

                row = layout.row(align=False)
                row.label(text="Blood color", icon="EYEDROPPER")
                row.scale_x=0.6
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "bloodcolor")
                row = layout.row(align=True)

                layout.prop(VeinsNode().inputs[0], "default_value", text="Veins",slider=True)
                row = layout.row(align=True)
                row.label(text="Veins Color", icon="EYEDROPPER")
                row.scale_x=0.6
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "veinscolor")

            else:
                layout.label(text="Legacy Model Support",icon="ERROR")
                layout.label(text="Some Options May Not Work", icon="QUESTION")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacySubsurface", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyWet", slider=True)  
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyWetSwitch", toggle=True, icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyWetSwitch else "HIDE_ON")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyOily", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyTan", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyTanLines", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyTanLinesType", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyScratches", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacySpanked", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyDirt", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyBlood", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "bloodcolor", text="Blood Color")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyVeins", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "veinscolor", text="Veins Color")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyFoam", slider=True)
        else:
            layout.label(text="Select a model first", icon="QUESTION")     

class LEGUYMELEFUNIFIEDUI_PT_Model_Makeup(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Makeup", icon="BRUSHES_ALL")

    def draw(self, context):
        
        layout = self.layout
        if bpy.context.scene.model_tools.model_name != "None":
            if not DirtNode(): 
                layout.label(text="Face", icon = 'SETTINGS')
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "Blush_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Blush_Bool else "HIDE_ON", toggle=True, text="Blush (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Blush_Bool else "Blush (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Blush_Bool:
                    row.scale_x=0.6
                    row.prop(FaceMakeupNode().inputs[9], "default_value", text="")
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "Eyeshadow_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Eyeshadow_Bool else "HIDE_ON", toggle=True, text="Eyeshadow (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Eyeshadow_Bool else "Eyeshadow (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Eyeshadow_Bool:
                    row.scale_x=0.6
                    row.prop(FaceMakeupNode().inputs[8], "default_value", text="")
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "Lips_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Lips_Bool else "HIDE_ON", toggle=True, text="Lipstick (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Lips_Bool else "Lipstick (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Lips_Bool:
                    row.scale_x=0.6
                    row.prop(FaceMakeupNode().inputs[6], "default_value", text="")
                    row = layout.row(align=True)
                    row.prop(FaceMakeupNode().inputs[7], "default_value", text="Lipstick Type")
                    row = layout.row(align=True)
                    row.prop(MetallicLipsNode().inputs[1], "default_value", text="Metallic Lipstick", slider=True)
                row = layout.row(align=True)
                row.prop(SetLipsGlossNode().inputs[0], "default_value", text="Lips Gloss", slider=True)
                row = layout.row(align=True)
                row.prop(FaceMakeupNode().inputs[10], "default_value", text="Mascara Smudge",slider=True)
                row = layout.row(align=True)
                row.prop(FaceMakeupNode().inputs[11], "default_value", text="Mascara Tears",slider=True)
                row = layout.row(align=True)
                row.prop(FaceMakeupNode().inputs[12], "default_value", text="Mascara Tears Type")


                layout.label(text="Hands", icon = 'SETTINGS')
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "Fingernails_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Fingernails_Bool else "HIDE_ON", toggle=True, text="Fingernails Polish (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Fingernails_Bool else "Fingernails Polish (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Fingernails_Bool:
                    row.scale_x=0.6
                    row.prop(SetFingerNailsColorNode().inputs[7], "default_value", text="")
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "French_Finger_Nails_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].French_Finger_Nails_Bool else "HIDE_ON", toggle=True, text="French Fingernails (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].French_Finger_Nails_Bool else "French Fingernails (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].French_Finger_Nails_Bool:
                    row.scale_x=0.6
                    row.prop(FingerFrenchNailsNode().inputs[3], "default_value", text="")
                row = layout.row(align=True)
                row.prop(FingerNailsSpecNode().inputs[0], "default_value", text="FingerNails Specular")
                row = layout.row(align=True)
                row.prop(ShaderNode(FingerNailsMat()).inputs[4], "default_value", text="FingerNails Metallic")


                layout.label(text="Feet", icon = 'SETTINGS')
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "Toenails_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Toenails_Bool else "HIDE_ON", toggle=True, text="Toenails Polish (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Toenails_Bool else "Toenails Polish (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Toenails_Bool:
                    row.scale_x=0.6
                    row.prop(SetToeNailsColorNode().inputs[7], "default_value", text="")        
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "French_Toes_Nails_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].French_Toes_Nails_Bool else "HIDE_ON", toggle=True, text="French Toenails (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].French_Toes_Nails_Bool else "French Toenails (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].French_Toes_Nails_Bool:
                    row.scale_x=0.6
                    row.prop(ToesFrenchNailsNode().inputs[3], "default_value", text="")
                row = layout.row(align=True)
                row.prop(ToeNailsSpecNode().inputs[0], "default_value", text="ToeNails Specular")
                row = layout.row(align=True)
                row.prop(ShaderNode(ToeNailsMat()).inputs[4], "default_value", text="ToeNails Metallic")

            else:
                layout.label(text="Legacy Model Support",icon="ERROR")
                layout.label(text="Some Options May Not Work",icon="QUESTION")
                layout.label(text="Face", icon = 'SETTINGS')
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyBlushColorBool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyBlushColorBool else "HIDE_ON", toggle=True, text="Blush (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyBlushColorBool else "Blush (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyBlushColorBool:
                    row.scale_x=0.6
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyBlushColor")
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyEyeshadowColorBool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyEyeshadowColorBool else "HIDE_ON", toggle=True, text="Eyeshadow (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyEyeshadowColorBool else "Eyeshadow (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyEyeshadowColorBool:
                    row.scale_x=0.6
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyEyeshadowColor")
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyLipstickColorBool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyLipstickColorBool else "HIDE_ON", toggle=True, text="Lipstick (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyLipstickColorBool else "Lipstick (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyLipstickColorBool:
                    row.scale_x=0.6
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyLipstickColor")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyLipstickType")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyGloss",  slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyMascaraSmudge",  slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyMascaraTears",  slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyMascaraTearsType", toggle=True, icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyMascaraTearsType else "HIDE_ON")

                layout.label(text="Hands", icon = 'SETTINGS')
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyFingerNailsColorBool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyFingerNailsColorBool else "HIDE_ON", toggle=True, text="Fingernails Polish (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyFingerNailsColorBool else "Fingernails Polish (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyFingerNailsColorBool:
                    row.scale_x=0.6
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyFingerNailsColor")

                layout.label(text="Feet", icon = 'SETTINGS')
                row = layout.row(align=True)
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyToeNailsColorBool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyToeNailsColorBool else "HIDE_ON", toggle=True, text="Toenails Polish (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyToeNailsColorBool else "Toenails Polish (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].LegacyToeNailsColorBool:                
                    row.scale_x=0.6
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyToeNailsColor")

        else:
            layout.label(text="Select a model first", icon="QUESTION")    

class LEGUYMELEFUNIFIEDUI_PT_Model_BodyType(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Body Morphs W/ Cloth Support", icon="OUTLINER_OB_ARMATURE")

    def draw(self, context):
        
        layout = self.layout
        MorphList1=['FBMBodySize','CTRLBodybuilder','CTRLFitness','FBMVoluptuous','FBMBodyTone','PBMBreastsCleavage','CTRLBreastsNatural','PBMBreastsSize','PBMBreastsSmall','PBMGlutesSize','PBMGlutesWidth','PBMThighsSize']
        MorphList2=["FBMHeavy","FBMPearFigure","FBMThin","PBMPregnant"]
        
        if bpy.context.scene.model_tools.model_name != "None":    
            row = layout.row(align=True)
            row.prop(bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig'],"charbodytype")
            
            for ob in MorphList1:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)
            
            row = layout.row(align=True) 
            layout.label(text="Computer Only Morphs", icon = 'SETTINGS')
            layout.label(text="Unchecked - Results May Vary", icon = 'QUESTION')
            
            for ob in MorphList2:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)            

        else:
            layout.label(text="Select a model first", icon="QUESTION")  
            
            
class LEGUYMELEFUNIFIEDUI_PT_Model_FaceDetails(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Face Details", icon="MONKEY")

    def draw(self, context):
        
        layout = self.layout

        if bpy.context.scene.model_tools.model_name != "None":         
            if "EJFantasyEars01" in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                layout.label(text="Ears Shape Select", icon = 'SETTINGS')
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].earstypeselect < 10:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["EJFantasyEars0'+str(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].earstypeselect)+'"]', text="Shape amount",slider=True)
                else:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["EJFantasyEars'+str(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].earstypeselect)+'"]', text="Shape amount",slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'],"earstypeselect", text="Shape Selection")

            if "Z VT Fangs Short" in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                layout.label(text="Teeth", icon = 'SETTINGS')
                if TeethColorNode():
                    layout.prop(TeethColorNode().inputs[1], "default_value", text="Teeth Color", slider=True)
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Z VT Fangs Short"]', text="Fangs",slider=True)
        
        else:
            layout.label(text="Select a model first", icon="QUESTION")  
            
            
class LEGUYMELEFUNIFIEDUI_PT_Model_HandsDetails(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Hands Details", icon="VIEW_PAN")

    def draw(self, context):
        
        layout = self.layout

        if bpy.context.scene.model_tools.model_name != "None": 
            layout.label(text="Finger Nails Shape Select", icon = 'SETTINGS')
            MorphListNails=["VYK Nails Round","VYK Nails Square","VYK Nails Stiletto"] 
            for ob in MorphListNails:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)            
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["PBMNailsLength"]', text="Finger Nails Length",slider=True)
            
            layout.label(text='Hand poses', icon = 'SETTINGS')
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["CTRLrHandFist"]', text="Right Hand Fist",slider=True)
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["CTRLlHandFist"]', text="Left Hand Fist",slider=True)
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["CTRLrHandGrasp"]', text="Right Hand Grasp",slider=True)
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["CTRLlHandGrasp"]', text="Left Hand Grasp",slider=True)         


            

            layout.label(text='Other Hands Morphs', icon = 'SETTINGS')
            MorphListHands=["PBMHandsThickness","Finger Knuckles","Finger Tendons","Flexor Carpi L","Flexor Carpi R","PBMWristSize"]
            for ob in MorphListHands:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)

        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Model_FeetDetails(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Feet Details", icon="MOD_DYNAMICPAINT")

    def draw(self, context):
        
        layout = self.layout

        if bpy.context.scene.model_tools.model_name != "None": 
            if "Testes" not in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].parent.data.bones:
                if "NecDAZ Realistic Feet" not in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.label(text="Feet Shape Select", icon = 'SETTINGS')
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Real Feet '+str(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].feettypeselect)+'"]', text="Shape amount",slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'],"feettypeselect", text="Shape Selection")
                
                else:
                    layout.label(text="NecDaz Feet Shapes", icon='SETTINGS')
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Realistic Feet"]', text="Base Shape", slider=True)
                    layout.label(text="Additive Shapes")
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 1"]', text="Shape 1 - Greek", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 2"]', text="Shape 2 - German", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 3"]', text="Shape 3 - Fantasy", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 4"]', text="Shape 4 - East Asian", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 5"]', text="Shape 5 - African", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 6"]', text="Shape 6 - Aboriginal", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 7"]', text="Shape 7 - Himiko", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Form 8"]', text="Shape 8 - Norwegian", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Anime_Foot"]', text="Shape 9 - Anime", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Cute_Foot"]', text="Shape 10 - Cute", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Classy_Foot"]', text="Shape 11 - Classy", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Classy_Foot2"]', text="Shape 12 - Classy 2", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Petite_Foot"]', text="Shape 13 - Petite", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Stubby_Foot"]', text="Shape 14 - Stubby", slider=True)
                
                    layout.label(text="Adjustments")
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Foot_Shapely"]', text="Shapely Foot", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["BigToe_CreaseDetail"]', text="Big Toe Crease Detail", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Foot_PointedAdjustment"]', text="Foot Pointed Adjustment", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["SoleFlatten_Simple"]', text="Sole Flatten_Simple", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["SoleIndent_Detail"]', text="Sole Indent_Detail", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Soles_BallLarger"]', text="Soles Ball Larger", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["ToesFlatten_Simple"]', text="Toes Flatten_Simple", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["Toes_HammerShape"]', text="Toes HammerShape", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Toenails Morph"]', text="Toe Nails Shape", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDaz Crease Fix"]', text="Crease Fix", slider=True)
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["NecDAZ Curvature"]', text="Curvature", slider=True)
                    
            layout.label(text="Other Feet Morphs", icon = 'SETTINGS')
            MorphListFeet=["Ankle Detail","Toe Tendons","Toes Longer","Toes Skinny","Feet Cavity"]
            for ob in MorphListFeet:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)

            if not DirtNode():
                layout.label(text='Soles', icon = 'SETTINGS')
                row = layout.row(align=True)

                row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "Sole_Blush_Bool", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Sole_Blush_Bool else "HIDE_ON", toggle=True, text="Soles Blush (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Sole_Blush_Bool else "Soles Blush (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].Sole_Blush_Bool:
                    row.scale_x=0.6
                    row.prop(SoleBlushNode().inputs[2], "default_value", text="")
                row = layout.row(align=True)
                row.prop(FeetDetailsNode().inputs[2], "default_value", text="Soles Wrinkles")
                row = layout.row(align=True)
                row.prop(FeetDetailsNode().inputs[0], "default_value", text="Soles Crunch Right")         
                row = layout.row(align=True) 
                row.prop(FeetDetailsNode().inputs[1], "default_value", text="Soles Crunch Left")         

        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Model_BodyDetails(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Body Details", icon="CON_ARMATURE")

    def draw(self, context):
        
        layout = self.layout

        if bpy.context.scene.model_tools.model_name != "None": 
            layout.label(text="Torso", icon = 'SETTINGS')
            MorphListTorso=["Abdomen_StyleAthletic","Abdomen_StyleSofter", "PBMNavelDepth","PBMNavelOut","External Oblique Lower","External Oblique Upper","Iliac Line Lower","Natural Abdominals","Rib Bones","Ribs_ChestStretched","Round Hips","Strong Clavicle","Thin Sternocleidomastoid","PBMStomachSoften","PBMLineaAlbaDepth","PBMTrapsSize"]
            for ob in MorphListTorso:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)

            layout.label(text="Breasts", icon = 'SETTINGS')
            MorphListBreasts=["PBMAreolaeDiameter","PBMAreolaePerk","PBMNipplesDepth","PBMNipplesDiameter","PBMBreastsUnderCurve","PBMBreastsUpwardSlope","PBMBreastsDiameter","R Breast Assymetry"]
            for ob in MorphListBreasts:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)

            
                                            
            layout.label(text="Back", icon = 'SETTINGS')
            MorphListBack=["Back_Toned","Dimples Of Venus 1","Fold Under Scapula","Lower Scapula","CTRLGluteCrease","PBMLatsSize","PBMScapulaDepth"]
            for ob in MorphListBack:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)            

            
            layout.label(text="Arms", icon = 'SETTINGS')
            MorphListArms=["Armpits_RaiseDetail", "Armpits_Athletic","Arm_Toned", "Outer Elbows","Shoulders Shape 02","Shoulders Shape 03","PBMForearmsSize","PBMUpperArmsSize"]
            for ob in MorphListArms:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)  
      

            layout.label(text="Legs", icon = 'SETTINGS')
            MorphListLegs=["Leg_Toned","Knee Back","Kneebones Detail","L Fasciae Latae Tensor","R Fasciae Latae Tensor","Shins Tone","PBMShinsSize"]
            for ob in MorphListLegs:
                if ob in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig']:
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+ob+'"]', text=property_name_cleanup(ob), slider=True)  
    

        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Model_Genitals(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Genitals Details", icon="FUND")

    def draw(self, context):
        
        layout = self.layout

        if bpy.context.scene.model_tools.model_name != "None":
            if "Testes" not in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].parent.data.bones:
                if not DirtNode(): 
                    row = layout.row(align=True)
                    row.label(icon="EYEDROPPER")
                    row.prop(GenitaliaGroupNode().inputs[2], "default_value", text="Gen color")
                    row = layout.row(align=True)
                    row.label(icon="EYEDROPPER")
                    row.prop(GenitaliaMakeupNode().inputs[7], "default_value", text="Gen Swell color")
                    row = layout.row(align=True)
                    if PussyWetness():
                        row.prop(PussyWetness().inputs[0], "default_value", text="Pussy Wetness")
                        row = layout.row(align=True)
                    

                    row.label(text="Genitals Shape Select", icon = 'SETTINGS')
                    row = layout.row(align=True)
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["PBMGensClose0'+str(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].genstypeselect)+'"]', text="Shape amount",slider=True)
                    row = layout.row(align=True)
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'],"genstypeselect", text="Shape Selection")
                else:
                    layout.label(text="Legacy Model Support",icon="ERROR")
                    layout.label(text="Some Options May Not Work",icon="QUESTION")
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyGenColor", text="GenColor")
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "LegacyGenSwellColor", text="GenSwellColor")

            else:
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'],"genssizemenu")
                layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'],'["pCTRLDefaultPose"]', text="Gen Erect", slider=True)
                for modifier in bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].modifiers:
                    if modifier.type == 'MASK' and "Gens" in modifier.name:
                        row = layout.row(align=True)
                        row.label(text="Genitals Mask")
                        row.prop(modifier, "show_viewport", text="")
                        row.prop(modifier, "show_render", text="")            
        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Expressions(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Model"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}

    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Expressions", icon="PMARKER_ACT")
    
    def draw(self, context):
        layout = self.layout
        
        if bpy.context.scene.model_tools.model_name != "None":
            MorphListExpression=["Afraid","Angry","Bereft","Concentrate","Confident","Confused","Contempt","Desire","Disgust","Drunk","Excitement","Fear","Fierce","Flirting","Frown","Glare","Happy","Ignore","Ill","Incredulous","Irritated","Pain","Pleased","Pouty","Rage","Sad","Sarcastic","Scream","Serious","Shock","Silly","SmileFullFace","SmileOpenFullFace","Snarl","Surprised","Suspicious","Tired","Triumph","Wink"]
                    
            for ob in MorphListExpression:
                for key in bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].keys():
                    if ob in key and "eJCM" not in key and "facs_bs" not in key:
                        layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'], '["'+key+'"]', text=property_name_cleanup(key),slider=True)

        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Hairstyles(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Hairstyles"
    bl_label = "Hairstyles"
    bl_options = {"DEFAULT_CLOSED"}
        
    def draw(self, context):
        layout = self.layout
        
        row = layout.row(align=True)         
#        if len(HairObjListAvail) > 1:
        row.label(text="Hair list and properties", icon="USER")
        if bpy.context.scene.model_tools.model_name != "None":
            row = layout.row(align=True) 
            row.prop(bpy.context.scene.model_tools,"hair_name")

            if bpy.context.scene.model_tools.hair_name != "Bald":
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.hair_name],"additional_subdiv_hair", icon="MOD_SUBSURF", text="")
                if bpy.data.objects[bpy.context.scene.model_tools.hair_name].additional_subdiv_hair:
                    layout2 = layout.box()   
                    layout2.label(text="subdiv options", icon="MOD_SUBSURF")  

                    Hair_Name = bpy.context.scene.model_tools.hair_name
                    if bpy.data.objects[Hair_Name].modifiers:
                        for modifier in bpy.data.objects[Hair_Name].modifiers:
                            if modifier.type == "SUBSURF":
                                if bpy.data.objects[Hair_Name].additional_subdiv_hair:
                                    row2 = layout2.row(align=True)
                                    row2.label(text=Hair_Name)
                                    row2.prop(modifier,"levels",text="Viewport")
                                    row2.prop(modifier,"render_levels", text="Render")

                row = layout.row(align=True)   
                if bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent and bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent != bpy.context.scene.model_tools.model_name+ '_rig':
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent, "hide_viewport", text="Hide Hair Armature (On)" if bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent.hide_viewport else "Hide Hair Armature (Off)",icon="RESTRICT_SELECT_ON" if bpy.data.objects[bpy.context.scene.model_tools.hair_name].parent.hide_viewport else "HIDE_ON")
                row = layout.row(align=True)        
                row.prop(bpy.data.objects[bpy.context.scene.model_tools.hair_name], "custom_hair_color", icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.hair_name].custom_hair_color else "HIDE_ON", toggle=True, text="HairColor (On)" if bpy.data.objects[bpy.context.scene.model_tools.hair_name].custom_hair_color else "HairColor (Off)")
                if bpy.data.objects[bpy.context.scene.model_tools.hair_name].custom_hair_color:
                    row.scale_x=0.6
                    row.prop(bpy.data.objects[bpy.context.scene.model_tools.hair_name], "hair_color")                

        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Outfits(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Outfits"
    bl_label = "Outfits Settings"
    
#    poll = outfits_panel_poll

    def draw(self, context):
        layout = self.layout

class LEGUYMELEFUNIFIEDUI_PT_OutfitsList(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Outfits"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}

    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Outfits list", icon="MOD_CLOTH")
    
    def draw(self, context):
        layout = self.layout
        matlist=[]
        matlist2=[]

        if bpy.context.scene.model_tools.model_name != "None":        
            row=layout.row(align=True)
            row.prop(bpy.context.scene.model_tools, "outfit_name")
            
            if bpy.context.scene.model_tools.outfit_name !="Nude":
            
                 
                #Display subdivision options and alternate texture options
                OutfitListTemp = []
                row.prop(bpy.data.collections[bpy.context.scene.model_tools.outfit_name],"additional_subdiv", toggle=True, icon="MOD_SUBSURF", text="")
                row.prop(bpy.data.collections[bpy.context.scene.model_tools.outfit_name],"additional_texture_outfit", toggle=True, icon="SHADING_TEXTURE", text="")
                if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_subdiv:
                    layout2 = layout.box()
                    layout2.label(text="subdiv options", icon="MOD_SUBSURF")              
                if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_texture_outfit:
                    layout3 = layout.box()   
                    layout3.label(text="Alt textures options",icon="SHADING_TEXTURE")    
                for obj in bpy.data.collections[bpy.context.scene.model_tools.outfit_name].objects:
                    if obj.type == 'MESH':
                        OutfitListTemp.append(obj.name)
                        if bpy.data.objects[obj.name].modifiers:
                            for modifier in bpy.data.objects[obj.name].modifiers:
                                if modifier.type == "SUBSURF":
                                    if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_subdiv:
                                        row2=layout2.row(align=True)
                                        row2.label(text=obj.name)
                                        row2.prop(modifier,"levels",text="Viewport")
                                        row2.prop(modifier,"render_levels", text="Render")
                        if obj.data.materials:
                            for mat in obj.data.materials:
                                if mat != None and mat.use_nodes:
                                    if mat.name not in matlist:
                                        for node in mat.node_tree.nodes:
                                            if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                                                for input in node.inputs:
                                                    if input.name == "Texture Number" and input.type=="INT" and not input.links :
                                                        if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_texture_outfit:
                                                            row3 = layout3.row(align=True)
                                                            row3.prop(input,"default_value",text=mat.name)
                                                            matlist.append(mat.name)
                                                    elif input.name == "Texture Number" and input.type == 'VALUE' and input.links:
                                                        if type(input.links[0].from_node) is bpy.types.ShaderNodeValue:
                                                            if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_texture_outfit:
                                                                if node.outputs[0].links and node.outputs[0].links[0].to_socket.name == 'Diffuse':
                                                                    row3 = layout3.row(align=True)
                                                                    row3.prop(input.links[0].from_node.outputs[0],"default_value",text=mat.name)
                                                                    matlist.append(mat.name)
                                                    elif input.name == "Texture Number" and input.type == 'VALUE' and not input.links:
                                                        if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_texture_outfit:
                                                            if node.outputs[0].links and node.outputs[0].links[0].to_socket.name == 'Diffuse':
                                                                row3 = layout3.row(align=True)
                                                                row3.prop(input,"default_value",text=mat.name)
                                                                matlist.append(mat.name)

                #displays global outfit alternate textures
                if outfit_text_count() > 0:
                    layout.label(text="Alt outfit textures found : "+str(outfit_text_count()))
                    layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "outfittext", text="Outfit Color")   
                
                #displays correct collection objects                           
                for obj_name in sorted(OutfitListTemp):
                    col = layout.column(align=True)
                    row = col.row(align=True)
                    row.prop(bpy.data.objects[obj_name],"outfit_visibility",toggle=True, text=obj_name, icon='OUTLINER_OB_'+bpy.data.objects[obj_name].type)

                    #looks for custom properties and draws them
                    if additional_options_test(bpy.data.objects[obj_name]) or additional_morph_options_test(bpy.data.objects[obj_name]) or additional_mask_options_test(bpy.data.objects[obj_name]):
                        row.prop(bpy.data.objects[obj_name],"additional_options_show", toggle=True, icon="PREFERENCES")
                        
                        if bpy.data.objects[obj_name].additional_options_show:
                            if additional_options_test(bpy.data.objects[obj_name]):
                                layout2 = layout.box()
                                layout2.label(text="Mat Options", icon="MATERIAL") 
                                for mat in additional_options_test(bpy.data.objects[obj_name]):
                                    for node in mat.node_tree.nodes:
                                        if "UI - " in node.name and type(node) is bpy.types.ShaderNodeRGB:
                                            row2 = layout2.row(align=True)
                                            row2.prop(node.outputs[0],"default_value",text=str(node.name.split(' - ',1)[1]))
                                        elif "UI Bool - " in node.name and type(node) is bpy.types.ShaderNodeValue:
                                            row2 = layout2.row(align=True)                                            
                                            row2.prop(node,"custom_bool_prop",text="Bool "+str(node.name.split(' - ',1)[1]), toggle=True, icon="HIDE_OFF" if node.custom_bool_prop else "HIDE_ON")

                                        elif node.type == 'GROUP' and "UI Bool - " in node.node_tree.name:
                                            row2 = layout2.row(align=True)
                                            row2.prop(node,"custom_bool_prop",text="Bool "+str(node.node_tree.name.split(' - ',1)[1]), toggle=True, icon="HIDE_OFF" if node.custom_bool_prop else "HIDE_ON")
                                         
                                        elif "UI Float - " in node.name and type(node) is bpy.types.ShaderNodeValue:
                                            row2 = layout2.row(align=True)
                                            row2.prop(node, "custom_float_prop", text=str(node.name.split(' - ',1)[1]), slider=True)
                                            
                            if additional_morph_options_test(bpy.data.objects[obj_name]):
                                layout2 = layout.box()
                                layout2.label(text="Shape Keys", icon="SHAPEKEY_DATA") 
                                for key in additional_morph_options_test(bpy.data.objects[obj_name]):
                                    row2 = layout2.row(align=True)
                                    row2.prop(key,"value", text=str(key.name.split(' - ',1)[1]))
                                
                            if additional_mask_options_test(bpy.data.objects[obj_name]):
                                layout2 = layout.box()
                                layout2.label(text="Masks", icon="MOD_MASK")  
                                for mask in additional_mask_options_test(bpy.data.objects[obj_name]):                  
                                    row2 = layout2.row(align=True)
                                    row2.label(text=str(mask.name.split(' - ',1)[1]))
                                    row2.prop(mask,"show_viewport",text="")       
                                    row2.prop(mask,"show_render",text="") 
                                           
                        row.scale_x=1
                        
        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Heels(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Outfits"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}

    def draw_header(self, context):
        layout = self.layout
        layout.label(text='Heels Mode Select', icon="PINNED")
    
    def draw(self, context):
        layout = self.layout

        if bpy.context.scene.model_tools.model_name != "None":           
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "heelsmodeselect")


        else:
            layout.label(text="Select a model first", icon="QUESTION") 

class LEGUYMELEFUNIFIEDUI_PT_Extras(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Outfits"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}

    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Extras", icon="PLUS")  
    
    def draw(self, context):
        layout = self.layout
        
        matlist=[]
        matlist2=[]

        for collection in bpy.data.collections:
            if "Extras" in collection.name:
                row0 = layout.row(align=True)
                row0.label(text=collection.name, icon="PLUS")               
                row0.prop(collection,"additional_subdiv_extras", toggle=True, icon="MOD_SUBSURF", text="")
                row0.prop(collection,"additional_texture_extras", toggle=True, icon="SHADING_TEXTURE", text="")
                if collection.additional_subdiv_extras:
                    layout2 = layout.box()
                    layout2.label(text="subdiv options", icon="MOD_SUBSURF")  
                if collection.additional_texture_extras:
                    layout3 = layout.box()   
                    layout3.label(text="Alt textures options",icon="SHADING_TEXTURE")  
                for obj in collection.objects:
                    if obj.type == 'MESH':
                        if bpy.data.objects[obj.name].modifiers:
                            for modifier in bpy.data.objects[obj.name].modifiers:
                                if modifier.type == "SUBSURF":
                                    if collection.additional_subdiv_extras:
                                        row2=layout2.row(align=True)
                                        row2.label(text=obj.name)
                                        row2.prop(modifier,"levels",text="Viewport")
                                        row2.prop(modifier,"render_levels", text="Render")
                        if obj.data.materials:
                            for mat in obj.data.materials:
                                if mat != None and mat.use_nodes:
                                    if mat.name not in matlist:
                                        for node in mat.node_tree.nodes:
                                            if node.type == 'GROUP' and "Texture Selector" in node.node_tree.name:
                                                for input in node.inputs:
                                                    if input.name == "Texture Number" and input.type=="INT" and not input.links:
                                                        if collection.additional_texture_extras:
                                                            row3 = layout3.row(align=True)
                                                            row3.prop(input,"default_value",text=mat.name)  
                                                            matlist.append(mat.name)
                                                    elif input.name == "Texture Number" and input.type == 'VALUE' and input.links:
                                                        if type(input.links[0].from_node) is bpy.types.ShaderNodeValue:
                                                            if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_texture_outfit:
                                                                if node.outputs[0].links and node.outputs[0].links[0].to_socket.name == 'Diffuse':
                                                                    row3 = layout3.row(align=True)
                                                                    row3.prop(input.links[0].from_node.outputs[0],"default_value",text=mat.name)
                                                                    matlist.append(mat.name)
                                                    elif input.name == "Texture Number" and input.type == 'VALUE' and not input.links:
                                                        if bpy.data.collections[bpy.context.scene.model_tools.outfit_name].additional_texture_outfit:
                                                            if node.outputs[0].links and node.outputs[0].links[0].to_socket.name == 'Diffuse':
                                                                row3 = layout3.row(align=True)
                                                                row3.prop(input,"default_value",text=mat.name)
                                                                matlist.append(mat.name)


                #displays correct collection objects   
                        col = layout.column(align=True)
                        row = col.row(align=True)
                        row.prop(obj,"outfit_visibility",toggle=True, text=obj.name, icon='OUTLINER_OB_'+bpy.data.objects[obj.name].type)

                    #looks for custom properties and draws them
                        if additional_options_test(obj) or additional_morph_options_test(obj) or additional_mask_options_test(obj):
                            row.prop(obj,"additional_options_show", toggle=True, icon="PREFERENCES")
                            if obj.additional_options_show:
                                if additional_options_test(obj):
                                    layout2 = layout.box()                                    
                                    layout2.label(text="Mat Options", icon="MATERIAL") 
                                    for mat in additional_options_test(obj):
                                        for node in mat.node_tree.nodes:
                                            if "UI - " in node.name and type(node) is bpy.types.ShaderNodeRGB:
                                                row2 = layout2.row(align=True)
                                                row2.prop(node.outputs[0],"default_value",text=str(node.name.split(' - ',1)[1]))
                                            elif "UI Bool - " in node.name and type(node) is bpy.types.ShaderNodeValue:
                                                row2 = layout2.row(align=True)
                                                row2.prop(node,"custom_bool_prop",text="Bool "+str(node.name.split(' - ',1)[1]), toggle=True, icon="HIDE_OFF" if node.custom_bool_prop else "HIDE_ON")

                                            elif node.type == 'GROUP' and "UI Bool - " in node.node_tree.name:
                                                row2 = layout2.row(align=True)
                                                row2.prop(node,"custom_bool_prop",text="Bool "+str(node.node_tree.name.split(' - ',1)[1]), toggle=True, icon="HIDE_OFF" if node.custom_bool_prop else "HIDE_ON")
                                             
                                            elif "UI Float - " in node.name and type(node) is bpy.types.ShaderNodeValue:
                                                row2 = layout2.row(align=True)
                                                row2.prop(node, "custom_float_prop", text=str(node.name.split(' - ',1)[1]), slider=True)
                                if additional_morph_options_test(obj):
                                    layout2 = layout.box()
                                    layout2.label(text="Shape Keys", icon="SHAPEKEY_DATA")                                     
                                    for key in additional_morph_options_test(obj):
                                        row2 = layout2.row(align=True)
                                        row2.label(text="", icon="SHAPEKEY_DATA")
                                        row2.prop(key,"value",text=str(key.name.split(' - ',1)[1]))                                              

                                if additional_mask_options_test(bpy.data.objects[obj_name]):
                                    layout2 = layout.box()
                                    layout2.label(text="Masks", icon="MOD_MASK")  
                                    for mask in additional_mask_options_test(bpy.data.objects[obj_name]):                  
                                        row2 = layout2.row(align=True)
                                        row2.label(text=str(mask.name.split(' - ',1)[1]))
                                        row2.prop(mask,"show_viewport",text="")       
                                        row2.prop(mask,"show_render",text="") 
                        row.scale_x=1


class LEGUYMELEFUNIFIEDUI_PT_Rig(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = "Armature Settings"
    
    def draw(self, context):
        layout = self.layout



class LEGUYMELEFUNIFIEDUI_PT_RigLayers(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text='Body Armature Layers', icon="ARMATURE_DATA")

    def draw(self, context):
        
        layout = self.layout
        if bpy.context.scene.model_tools.model_name != "None":        
        
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=16, toggle=True, text="Main")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=17, toggle=True, text="Face")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=10, toggle=True, text="Face Rig")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=11, toggle=True, text="Spine Tweak")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=22, toggle=True, text="Left Hand")
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=23, toggle=True, text="Right Hand")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=24, toggle=True, text="Left Foot")
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=25, toggle=True, text="Right Foot")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=14, toggle=True, text="Face Extra")
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=2, toggle=True, text="Cloth & Hair")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=15, toggle=True, text="Gens")
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=13, toggle=True, text="Breast & Butt")
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "showFK",toggle=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "showIK",toggle=True)
            row = layout.row(align=True)
            row.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ '_rig'].data, 'layers', index=12, toggle=True, text="Master")

        else:
            layout.label(text="Select a model first", icon="QUESTION")

class LEGUYMELEFUNIFIEDUI_PT_Gaze(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text='Gaze Control', icon="OUTLINER_OB_CAMERA")

    def draw(self, context):
        
        layout = self.layout
        if bpy.context.scene.model_tools.model_name != "None": 
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "gazemode",toggle=True, icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].gazemode else "HIDE_ON", text="Eyes follow gaze (on)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].gazemode else "Eyes follow gaze (off)") 
        else:
            layout.label(text="Select a model first", icon="QUESTION")

class LEGUYMELEFUNIFIEDUI_PT_Mirror(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text='Mirror Mode', icon="MOD_MIRROR")

    def draw(self, context):
        
        layout = self.layout
        if bpy.context.scene.model_tools.model_name != "None":       
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "mirrormode",toggle=True, icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mirrormode else "HIDE_ON", text="Mirror mode (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mirrormode else "Mirror mode (Off)")
        else:
            layout.label(text="Select a model first", icon="QUESTION")

class LEGUYMELEFUNIFIEDUI_PT_IKFK(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text='IK/FK', icon="GROUP_BONE")

    def draw(self, context):
        
        layout = self.layout


        if bpy.context.scene.model_tools.model_name != "None":  
            layout.operator('ops.toggle_ik')
            layout.operator('ops.toggle_fk') 
            row = layout.row(align=True)
            row.operator('ops.toggle_ik_arms')
            row.operator('ops.toggle_ik_legs')
            row = layout.row(align=True)
            row.operator('ops.toggle_fk_arms')
            row.operator('ops.toggle_fk_legs')
            row = layout.row(align=True)
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "kneemode",toggle=True, icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].kneemode else "HIDE_ON", text="Knees Follow Feet (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].kneemode else "Knees Follow Feet (Off)")
            layout.prop(bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'], "elbowmode",toggle=True, icon="HIDE_OFF" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].elbowmode else "HIDE_ON", text="Elbows Follow Hands (On)" if bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].elbowmode else "Elbows Follow Hands (Off)")
            
            layout.label(text="Fixes for older models")
            
            layout.operator('ops.fix_ik', text = "Fix IK Knees&Elbows")
            layout.operator('ops.fix_hip_locked', text = "Fix Hip Locked In IK")
  

        else:
            layout.label(text="Select a model first", icon="QUESTION")
            

class LEGUYMELEFUNIFIEDUI_PT_ClearPose(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text='Clear Pose', icon="SHADERFX")

    def draw(self, context):
        
        layout = self.layout            
        layout.operator("daz.clear_pose")


class LEGUYMELEFUNIFIEDUI_PT_ImportPose(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Rig"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text='Import from Daz', icon="DOCUMENTS")

    def draw(self, context):
        
        layout = self.layout 
        if not bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mirrormode :
            layout.operator("daz.import_pose")
            layout.operator("daz.import_action")
        else:
            layout.label(text="Quit mirror mode to unhide", icon="GHOST_DISABLED")

class LEGUYMELEFUNIFIEDUI_PT_Tools_ChildOf(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Tools_ChildOf"
    bl_label = "Parent bones"
    bl_options = {"DEFAULT_CLOSED"}
    
    def draw(self, context):
        
        layout = self.layout
        if bpy.context.scene.model_tools.model_name != "None":  
            arm = bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig']
            
            layout.label(text="Legacy tool - unsupported", icon="ERROR")
            
            layout.label(text="Force one Bone to follow another Bone.")
            
            box = layout.box()
            box.label(text="Select two bones:", icon="BONE_DATA")
            box.label(text="        - the first will be the parent,")
            box.label(text="        - the second will be the child.")
            box.prop(arm, "childof_influence")
            layout.operator('ops.childof', text="Enable").clean = 0
            
            box = layout.box()
            
            box.label(text="Remove Parent instances.", icon="X")
            box.label(text="Note: this clean the UI generated modifiers only.")
            layout.operator('ops.childof', text="Clean").clean = 1

        else:
            layout.label(text="Select a model first", icon="QUESTION")

class LEGUYMELEFUNIFIEDUI_PT_Import(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Import"
    bl_label = "Outfit Library Tools"
    
    def draw(self, context):
        layout = self.layout
    

class LEGUYMELEFUNIFIEDUI_PT_Tutorial(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Import"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Links to outfits & Tutorials", icon="BOOKMARKS")

    def draw(self, context):
        
        layout = self.layout
        layout.operator('ops.open_link', text="Outfit Library 2.0", icon = "WORLD").url = bpy.context.scene.url_outfitlibrary           
        layout.operator('ops.open_link', text="Outfit Library (old)", icon = "WORLD").url = bpy.context.scene.url_videotut 


class LEGUYMELEFUNIFIEDUI_PT_UsefulButtons(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Import"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Outfit Library Tools", icon="BOOKMARKS")

    def draw(self, context):
        
        layout = self.layout
        if not bpy.data.objects[bpy.context.scene.model_tools.model_name+ ' Body'].mirrormode :
            layout.operator("daz.change_armature")
            layout.operator("daz.transfer_shapekeys")
            if bpy.context.scene.model_tools.model_name != "None":          
                layout.prop(bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig'],"reapplychar",toggle=True)
                layout.prop(bpy.data.armatures[bpy.context.scene.model_tools.model_name+ '_rig'],"removechar",toggle=True)

        else:
            layout.label(text="Quit mirror mode to unhide", icon="GHOST_DISABLED")

class LEGUYMELEFUNIFIEDUI_PT_DevTools(MainPanel, bpy.types.Panel):
    bl_parent_id = "LEGUYMELEFUNIFIEDUI_PT_Import"
    bl_label = ""
    bl_options = {"DEFAULT_CLOSED"}


    def draw_header(self, context):
        layout = self.layout
        layout.label(text="Dev tools (not for users)", icon="BOOKMARKS")

    def draw(self, context):
        
        layout = self.layout
      
        layout.operator("daz.import_custom_morphs")
        layout.operator("daz.merge_rigs")
        layout.operator("daz.copy_materials")
        layout.operator("daz.merge_geografts")
        layout.operator("daz.add_shapekey_drivers")
        layout.operator("daz.remove_shapekey_drivers")
        layout.operator("daz.add_extra_face_bones")
        layout.operator("daz.make_all_bones_posable")
        layout.operator("daz.add_mannequin")
        layout.operator('ops.clean_invalid_drivers', text="Clean All Invalid Drivers")
        layout.label(text="")
        layout.operator('ops.remove_drivers', text="Remove All Drivers")
        layout.operator('ops.remove_obj_custom_properties', text="Remove Obj Properties")
        layout.operator('ops.remove_rig_custom_properties', text="Remove Rig Properties")
        

class LEGUYMELEFUNIFIEDUI_PT_Links(MainPanel, bpy.types.Panel):
    bl_idname = "LEGUYMELEFUNIFIEDUI_PT_Links"
    bl_label = "Links"
    bl_options = {"DEFAULT_CLOSED"}
    
    def draw(self, context):
        layout = self.layout
        

        layout.label(text="Social profiles/contacts", icon="BOOKMARKS")
        
        layout.operator('ops.open_link', text="LeGuymelef - Patreon", icon = "WORLD").url = bpy.context.scene.url_patreon
        layout.operator('ops.open_link', text="LeGuymelef - Twitter", icon = "WORLD").url = bpy.context.scene.url_twitter
        layout.operator('ops.open_link', text="LeGuymelef - SmutBase", icon = "WORLD").url = bpy.context.scene.url_smutbase

   
# ------------------------------------------------------------------------
#    Register
# ------------------------------------------------------------------------

classes = (
    Link_Button,
    ChildOf,
    ModelInfos,
    fix_IK,
    fix_hip_locked,
    clean_invalid_drivers,
    remove_drivers,
    remove_obj_custom_properties,
    remove_rig_custom_properties,
    toggle_ik,
    toggle_fk,
    toggle_ik_arms,
    toggle_ik_legs,
    toggle_fk_arms,
    toggle_fk_legs,
    LEGUYMELEFUNIFIEDUI_PT_ModelSelection,
    LEGUYMELEFUNIFIEDUI_PT_Engine,
    LEGUYMELEFUNIFIEDUI_PT_ModelEngine,
    LEGUYMELEFUNIFIEDUI_PT_Performance,
    LEGUYMELEFUNIFIEDUI_PT_Model,
    LEGUYMELEFUNIFIEDUI_PT_Model_SkinProperties,
    LEGUYMELEFUNIFIEDUI_PT_Model_Makeup,
    LEGUYMELEFUNIFIEDUI_PT_Model_BodyType,
    LEGUYMELEFUNIFIEDUI_PT_Model_FaceDetails,
    LEGUYMELEFUNIFIEDUI_PT_Model_HandsDetails,
    LEGUYMELEFUNIFIEDUI_PT_Model_FeetDetails,
    LEGUYMELEFUNIFIEDUI_PT_Model_BodyDetails,
    LEGUYMELEFUNIFIEDUI_PT_Model_Genitals,
    LEGUYMELEFUNIFIEDUI_PT_Hairstyles,
    LEGUYMELEFUNIFIEDUI_PT_Outfits,
    LEGUYMELEFUNIFIEDUI_PT_OutfitsList,
    LEGUYMELEFUNIFIEDUI_PT_Heels,
    LEGUYMELEFUNIFIEDUI_PT_Extras,
    LEGUYMELEFUNIFIEDUI_PT_Rig,
    LEGUYMELEFUNIFIEDUI_PT_RigLayers,
    LEGUYMELEFUNIFIEDUI_PT_Gaze,
    LEGUYMELEFUNIFIEDUI_PT_Mirror,
    LEGUYMELEFUNIFIEDUI_PT_IKFK,
    LEGUYMELEFUNIFIEDUI_PT_ClearPose,
    LEGUYMELEFUNIFIEDUI_PT_ImportPose,
    LEGUYMELEFUNIFIEDUI_PT_Expressions,
    LEGUYMELEFUNIFIEDUI_PT_Import,
    LEGUYMELEFUNIFIEDUI_PT_Tutorial,
    LEGUYMELEFUNIFIEDUI_PT_UsefulButtons,
    LEGUYMELEFUNIFIEDUI_PT_DevTools,
    LEGUYMELEFUNIFIEDUI_PT_Tools_ChildOf,
    LEGUYMELEFUNIFIEDUI_PT_Links,
    DAZ_OT_SnapSimpleFK,
    DAZ_OT_SnapSimpleIK
)

def register():
    from bpy.utils import register_class

    bpy.types.Object.DazArmIK_L = FloatProperty(name="Left Arm IK", default=0.0, precision=3, min=0.0, max=1.0)
    bpy.types.Object.DazArmIK_R = FloatProperty(name="Right Arm IK", default=0.0, precision=3, min=0.0, max=1.0)
    bpy.types.Object.DazLegIK_L = FloatProperty(name="Left Leg IK", default=0.0, precision=3, min=0.0, max=1.0)
    bpy.types.Object.DazLegIK_R = FloatProperty(name="Right Leg IK", default=0.0, precision=3, min=0.0, max=1.0)

    for cls in classes:
        register_class(cls)

    bpy.types.Scene.model_tools = bpy.props.PointerProperty(type=ModelInfos)

def unregister():
    
    from bpy.utils import unregister_class

    del bpy.types.Scene.model_tools
    for cls in reversed(classes):
        unregister_class(cls)

if __name__ == "__main__":
    register()